#ifndef _OGLWIDGETFLOATING2_
#define _OGLWIDGETFLOATING2_

#include <qgl.h>
#include "all.h"

class OGLWidgetFloating2 : public QGLWidget 
{
public:
	OGLWidgetFloating2( QWidget* parent, const char* name, QWidget* parentForm );
	~OGLWidgetFloating2 ( );

public: //VARIABLES
	// world center
	GLfloat			XC, YC, ZC;					//
    int				X,	Y,	dX, dY;				//
    GLfloat			Cx, Cy, Cz;					//
    double			m_viewScale;				//
    int				main_height, main_width;	//
    int     		enable_picking;				//
    float			xCoord[MAX_POINTS];			//
    float			yCoord[MAX_POINTS];			//
    float			zCoord[MAX_POINTS];			//

	// lighting
    GLfloat 		global_light0[4];			//

	// View-port parameters
    float			xMin;						//
    float			xMax;						//
    float			yMin;						//
    float			yMax;						//
    float			zNear;						//
    float			zFar;						//

	// mouse event data handlers
    float			startY;						//
    int				xBegin, xNext;				//
    int				yBegin, yNext;				//
	int				modkey;						//
    int				button;						//
    int				mouseModifiers;				//
	int				mouseButtons;				//

	// mouse: picking data handlers
	int				litVertex;					//
    int				movingPoint;				//


public: //FUNCTIONS
	/* ADMINISTRATION */
	//window operations
	void			initializeGL		( void );			//
	void			init				( void );			//
	void			initLighting		( void );			//
	void			paintGL				( void );			//
	void			resizeGL			( int wd, int ht ); 		//
	void			resetApp			( void );			//
	int				saveScreenAsBMP		( void );

	//event handlers
    void			keyPressEvent			( QKeyEvent *e );		//			
	void			mousePressEvent			( QMouseEvent *e );		//
	void			mouseReleaseEvent		( QMouseEvent *e );		//
	void			moveTransformedCoordinate	( float x, float y );	        //
	void			mouseMoveEvent			( QMouseEvent *e );		//
	void			mouseDoubleClickEvent	( QMouseEvent *e );		//

	// MOUSE PICKING 
	// mouse: picking data handlers
	int				totalPoints;				//

	// Mouse vertex pick handlers
	protected:
    void			addPoint					( int x, int y );			//
    //void 			moveTransformedCoordinate	(float x, float y);			//
    void 			motion            			( int x, int y );			//
    void 			processHits      			( GLint hits, GLuint buffer[] );	//
    void 			mousePickVertex  			( int x, int y );			//
	void			drawPoints					( GLenum mode );			//
	void			drawPoint					( float x,float y,float z,int size, int name, GLenum mode ); //



};


#endif
