#include "OGLWidgetMain.h"
#include "VisibleForm.h"
#include <qmessagebox.h>
#include <qstring.h>
#include <qimage.h>

VisibleForm* pForm;
GLfloat diffuseMaterial[4] = {0.5,0.5,0.5,1.0};
char qstr[300];

OGLWidgetMain::OGLWidgetMain( QWidget* parent, const char* name, QWidget* parentForm)
: QGLWidget( parent, name)
{
	pForm = (VisibleForm*) parentForm;
	init();
}

OGLWidgetMain::~OGLWidgetMain() 
{
	//fprintf(stderr,"~OGLWidgetMain()\n**************\n***********\n");
	pForm = NULL;
}

//#INITIALIZE
void OGLWidgetMain::initializeGL			( ) 
{
    glClearColor(0.23f,0.5f,0.65f,1.0f);
    initLighting();
    m_viewScale = 1.0;
}

void OGLWidgetMain::init					( void )
{
        // workspace center
    X=0; Y=0; dX=0; dY=0;
    XC = 0.0; YC = 0.0; ZC = -10.0;
    Cx = 0.0; Cy = 0.0; Cz = 0.0;

    // mouse stuff
    mouseButtons	= 0;
    button			= 0;
    mouseModifiers	= 0;
            
	// viewport dimensions
    xMin			= -1.0;
    xMax			=  1.0;
    yMin			= -1.0;
    yMax			=  1.0;
    zNear			=  5.0;
    zFar			= 25.0;

    main_height		= this->height();
    main_width		= this->width();
    
	// moust picking
    litVertex		= -1;
    enable_picking	= 1;
    movingPoint		= FALSE;
}

void OGLWidgetMain::initLighting			( void ) 
{
    //static const GLfloat light_model_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    //static const GLfloat light0_ambient[]		= {0.3f, 0.3f, 0.3f, 1.0f};
    //static const GLfloat light0_diffuse[]		= {0.9f, 0.9f, 0.9f, 0.9f};  
    //static const GLfloat light0_specular[]		= {1.0f, 1.0f, 1.0f, 1.0f};
    //static const GLfloat light0_shininess[]		= {100.0};
    //static const GLfloat light0_direction[]		= {0.0f, 0.0f, 10.0f, 0.0f};    
    //
    //static const GLfloat light1_ambient[]		= {0.3f, 0.3f, 0.3f, 1.0f};
    //static const GLfloat light1_diffuse[]		= {0.9f, 0.0f, 0.0f, 0.9f};  
    //static const GLfloat light1_specular[]		= {1.0f, 1.0f, 1.0f, 1.0f};
    //static const GLfloat light1_shininess[]		= {300.0};
    //static const GLfloat light1_direction[]		= {0.0f, 0.0f, 10.0f, 0.0f};    
    //
    //global_light0[0]=light0_direction[0];
    //global_light0[1]=light0_direction[1];
    //global_light0[2]=light0_direction[2];
    //global_light0[3]=light0_direction[3];
    //
    ///* Enable depth buffering for hidden surface removal. */
    //glDepthFunc(GL_LEQUAL);
    //glEnable(GL_DEPTH_TEST);
    //
    ///* Other misc features. */
    //glEnable(GL_LIGHTING);
    //glEnable(GL_NORMALIZE);
    //glShadeModel(GL_SMOOTH);
    //
    //glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
    //glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);    
    //glLightModelfv(GL_LIGHT_MODEL_AMBIENT, light_model_ambient);

    //glLightfv(GL_LIGHT0, GL_DIFFUSE,   light0_diffuse);
    //glLightfv(GL_LIGHT0, GL_POSITION,  light0_direction);
    //glLightfv(GL_LIGHT0, GL_AMBIENT,   light0_ambient);
    //glLightfv(GL_LIGHT0, GL_SPECULAR,  light0_specular);
    //glLightfv(GL_LIGHT0, GL_SHININESS, light0_shininess);
    //glEnable(GL_LIGHT0);     

    //glLightfv(GL_LIGHT1, GL_DIFFUSE,  light1_diffuse);
    //glLightfv(GL_LIGHT1, GL_POSITION, light1_direction);
    //glLightfv(GL_LIGHT1, GL_AMBIENT,  light1_ambient);
    //glLightfv(GL_LIGHT1, GL_SPECULAR, light1_specular);
    //glLightfv(GL_LIGHT1, GL_SHININESS,light1_shininess);
	
    //glEnable(GL_LIGHT0);
	float s[4];
	float ltc[4],ltp[4];
    ltp[0] = 0.0; ltp[1] = 0.1; ltp[2] = 1.0; ltp[3] = 0.0;
    ltc[0] = 1.0; ltc[1] = 1.0; ltc[2] = 1.0; ltc[3] = 1.0;

    static const GLfloat light_model_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    static const GLfloat light0_ambient[]		= {0.3f, 0.3f, 0.3f, 1.0f};
    static const GLfloat light0_diffuse[]		= {0.9f, 0.9f, 0.9f, 0.9f};  
    static const GLfloat light0_specular[]		= {0.0f, 0.0f, 0.0f, 1.0f};
    static const GLfloat light0_shininess[]		= {10.0};
    static const GLfloat light0_direction[]		= {0.0f, 0.0f, 10.0f, 1.0f};    
    
    global_light0[0]=light0_direction[0];
    global_light0[1]=light0_direction[1];
    global_light0[2]=light0_direction[2];
    global_light0[3]=light0_direction[3];

	/* Enable depth buffering for hidden surface removal. */
    glDepthFunc(GL_LEQUAL);
    glEnable(GL_DEPTH_TEST);
    
    /* Other misc features. */
    glEnable(GL_LIGHTING);
    glEnable(GL_NORMALIZE);
    glShadeModel(GL_SMOOTH);

    glMaterialfv (GL_FRONT_AND_BACK,GL_AMBIENT,pForm->mo->mata);
    glMaterialfv (GL_FRONT_AND_BACK,GL_DIFFUSE,pForm->mo->matd);
    glMaterialfv (GL_FRONT_AND_BACK,GL_SPECULAR,pForm->mo->mats);
    glMaterialf  (GL_FRONT_AND_BACK,GL_SHININESS,pForm->mo->shininess);

	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
    glEnable     (GL_LIGHTING);

    glLightfv    (GL_LIGHT0,GL_POSITION,ltp);
	glLightfv    (GL_LIGHT0,GL_DIFFUSE,ltc);
    glEnable     (GL_LIGHT0);
    glEnable     (GL_NORMALIZE);

} 


void OGLWidgetMain::resetApp				( void )
{
    m_viewScale = 1.0;

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glFrustum(xMin, xMax, yMin, yMax, zNear, zFar);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glScalef(m_viewScale, m_viewScale, m_viewScale);//@ scale factor
    glTranslatef(XC,YC,ZC);
}

void  OGLWidgetMain::resizeGL				( int wd, int ht )
{
    int w = wd;
    int h = ht;
    main_height = h;
    main_width = w;

    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    glFrustum(xMin, xMax, yMin, yMax, zNear, zFar);
    /* Viewing location of camera */
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glTranslatef(XC,YC,ZC);
    
}

//#EVENT MGMT
void OGLWidgetMain::mousePressEvent			( QMouseEvent *e )
{
    QMouseEvent *m = e;
    int x = m->x();
    int y = m->y();
    
    setFocus();

    X = x;
    Y =  main_height -y - 1;

    switch (m->button()){
        case  LeftButton:
            button = 0x1; /* our Left   bit code */
            break;
        case MidButton:
            button = 0x2; /* our Middle bit code */
            break;
        case RightButton:
            button = 0x4; /* our Right  bit code */
            break;
        default:
            break;
    }

    mouseButtons |= button;
    
    //@ Check if a vertex is lit
    if(button == 0x1){
        if( litVertex == -1 && pForm->mo->objectID==OBJCURVE && !(m->state() & ControlButton) && !(m->state() & ShiftButton) ){

                //@ Add a new vertex
            addPoint(X,Y);
        }
        else{
            movingPoint = TRUE;
        }   
    }
    
    updateGL();
}

void OGLWidgetMain::mouseDoubleClickEvent	( QMouseEvent *e ) 
{
	QMouseEvent *l_e = e;
	l_e = NULL;

	if(pForm->swapFrames)
		pForm->calbak_Swap_Frames();
	else if(pForm->swapFrames2)
		pForm->calbak_Swap_Frames_2();

}
void OGLWidgetMain::mouseReleaseEvent		( QMouseEvent *e )
{
    QMouseEvent *evnt = e;

    mouseButtons &= (~(button));
    if(button == 0x1){
        movingPoint = FALSE;
    }
    evnt = NULL;
    //pForm->mo->status.sprintf("%s"," ");
    //pForm->lb_status_text->setText(pForm->mo->status);
}

void OGLWidgetMain::moveTransformedCoordinate( float x, float y )
{

    GLint viewport[4],winHeight;
    GLdouble mvmatrix[16], projmatrix[16];
    GLdouble wx,wy,wz, objx, objy, objz;
    GLdouble origX, origY, origZ;
	origX = pForm->mo->ctrlPntList[litVertex].p3.d[0];
	origY = pForm->mo->ctrlPntList[litVertex].p3.d[1];
	origZ = pForm->mo->ctrlPntList[litVertex].p3.d[2];

    glGetDoublev(GL_MODELVIEW_MATRIX, mvmatrix);
    glGetDoublev(GL_PROJECTION_MATRIX, projmatrix);
    glGetIntegerv(GL_VIEWPORT,viewport);
    winHeight = viewport[3];
    
    if(gluProject(origX, origY, origZ, mvmatrix, projmatrix, viewport, &wx,&wy,&wz) == GL_FALSE){
        printf("gluProject() didn't work in moveTransformedCooordinates\n");
    }
    
    if(gluUnProject((GLdouble)x, 
                    (GLdouble)y,wz,mvmatrix,projmatrix,viewport, &objx,&objy,&objz) == GL_FALSE){
        printf("gluUnProject() didn't work in moveTransformedCooordinates\n");
    }	

	pForm->mo->ctrlPntList[litVertex].p3.d[0] = objx;
	pForm->mo->ctrlPntList[litVertex].p3.d[1] = objy;

    //xCoord[litVertex]=objx;
    //yCoord[litVertex]=objy;

	//buzzform();
	pForm->updateObject();
	pForm->notifyOGLWidgets();
}
void OGLWidgetMain::mouseMoveEvent			( QMouseEvent *e )
{
    QMouseEvent *m	= e;
    int		x		= m->x();
    int		y		= m->y();
    int		deltaY, deltaX;
    float	modelviewMatrix[16];
    int		nHatX, nHatY;
    float	thetaRad, thetaDeg;
    double  radius	= 250.0;
    float	drSquared;
	double	zval	= 0.0;
    
    //@ scaling
    double y1=0.0, y2=0.0;
    //@@
    
    xBegin = X;
    yBegin = Y;
    startY = Y;
    X = x;
    Y =  main_height - y - 1;	/* Invert to right-handed system */

    //@ scaling objects
    y1 = (double)yBegin;
    y2 = (double)Y;
    //@@

    xNext = X;
    yNext = Y;

   // Passive motion callback is simulate here with the
   // boolean movingPoint
    if( (enable_picking) && (!movingPoint) ) {
        mousePickVertex(x,y);
    }
    
    //case 0x1:  /* Left Mouse Button   */
    //if((m->state() & LeftButton) && (m->state() & ShiftButton)) {
    if((m->state() & LeftButton)) {    
        if(movingPoint == TRUE && litVertex > -1){
			if( !(m->state() & ShiftButton) ) {
                moveTransformedCoordinate(X,Y);
            }
            else if( (m->state() & ShiftButton) ){
                //shift is pressed so move in Z
                deltaY = Y - (int)startY;
                //zCoord[litVertex] = zCoord[litVertex] - (float)deltaY/20.0;
				zval = pForm->mo->ctrlPntList[litVertex].p3.d[2] - (float)deltaY/150.0;
				printf("zval[%d] = %f, znear = %f, zfar = %f\n",litVertex,zval,zNear,zFar);
				pForm->mo->ctrlPntList[litVertex].p3.d[2] = zval;
                if(zval > zNear){
                    pForm->mo->ctrlPntList[litVertex].p3.d[2] = zval;
                }
                if(zval < (zNear - (zFar - zNear))){
                    pForm->mo->ctrlPntList[litVertex].p3.d[2] =(zNear - (zFar - zNear)) ;
                }
            }
        }
    }
    if(pForm->mo->objectID==OBJCURVE && pForm->mo->whichCurve==OBJSPLINE) {
        if( (m->state() & LeftButton) && (m->state() & ControlButton) ){
            
            deltaX = xNext - xBegin;
            deltaY = yNext - yBegin;
            nHatX = -deltaY;
            nHatY = deltaX;
                //get the amount of rotation
            drSquared = pow(deltaX,2) + pow(deltaY,2);
            thetaRad = acos(radius/(sqrt(pow(radius,2) + drSquared)));
            thetaDeg = (thetaRad * 180) / M_PI;
                //translate to center
            glGetFloatv(GL_MODELVIEW_MATRIX,modelviewMatrix);
            glMatrixMode(GL_MODELVIEW);
            glLoadIdentity();
            glTranslatef(XC,YC,ZC);
            glTranslatef(Cx, Cy, 0);
            
            glRotatef(thetaDeg,nHatX,nHatY,0);
                //tranlsate back
            glTranslatef(-Cx, -Cy, 0);
            glTranslatef(-XC,-YC,-ZC);
            glMultMatrixf(modelviewMatrix);
        }
    }
    else if(pForm->mo->whichCurve==OBJKNOT || pForm->mo->whichCurve==-1 || pForm->mo->whichCurve == OBJCURVELIST || pForm->mo->objectID == OBJSURFACE) {
        if( (m->state() & LeftButton) ){
            
            deltaX = xNext - xBegin;
            deltaY = yNext - yBegin;
            nHatX = -deltaY;
            nHatY = deltaX;
                //get the amount of rotation
            drSquared = 1.5*(pow(deltaX,2) + pow(deltaY,2));
            thetaRad = acos(radius/(sqrt(pow(radius,2) + drSquared)));
            thetaDeg = (thetaRad * 180) / M_PI;
                //translate to center
            glGetFloatv(GL_MODELVIEW_MATRIX,modelviewMatrix);
            glMatrixMode(GL_MODELVIEW);
            glLoadIdentity();
            glTranslatef(XC,YC,ZC);
            glTranslatef(Cx, Cy, 0);
	        
            glRotatef(thetaDeg,nHatX,nHatY,0);
                //tranlsate back
            glTranslatef(-Cx, -Cy, 0);
            glTranslatef(-XC,-YC,-ZC);
            glMultMatrixf(modelviewMatrix);
            //pForm->mo->status.sprintf("%s","Rotation...");
            //pForm->lb_status_text->setText(pForm->mo->status);
        }
    }
    
        //case 0x4:  /* Right Mouse Button  */
        //translating
    if( (m->state() & RightButton) && (m->state() & ShiftButton)) {
        
        glGetFloatv(GL_MODELVIEW_MATRIX,modelviewMatrix);
        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
        glTranslatef(((float)xNext-xBegin)/((float)main_width/2.0),
                     ((float)yNext-yBegin)/((float)main_height/2.0),0);
        glMultMatrixf(modelviewMatrix);

        
        Cx = Cx + ((float)xNext-xBegin)/((float)main_width/2.0);
        Cy = Cy + ((float)yNext-yBegin)/((float)main_height/2.0);
    }
    else  if((m->state() & RightButton) && !(m->state() & ShiftButton))//scaling
    {
        m_viewScale *= 1 + (y2 - y1)/((double)main_height*0.5);
        if(m_viewScale<0.5)
            m_viewScale=0.5;
        if(m_viewScale>4.0)
            m_viewScale=4.0;
    }        

    updateGL();
}

void OGLWidgetMain::keyPressEvent			( QKeyEvent *e )
{
    QMessageBox mb( "Exiting...",
                    "Really quit?",
                    QMessageBox::NoIcon,
                    QMessageBox::Yes | QMessageBox::Default,
                    QMessageBox::No,QMessageBox::NoButton );
    
    switch(e->key()) {
        
        case Key_Space:
            break;

        case Key_H:
			if(e->state()&&ShiftButton) {
				pForm->mo->showOnScreenHelp = !pForm->mo->showOnScreenHelp;
			}
			else {
	            pForm->calbak_Help();
			}
            break;
        
        case Key_A:
            pForm->mo->showAxes = !pForm->mo->showAxes;
            if(pForm->mo->showAxes == 1)
                pForm->cb_axes->setChecked(TRUE);
            else
                pForm->cb_axes->setChecked(FALSE);
            break;
		
        case Key_B:
            break;
            
        case Key_C:
            pForm->mo->showCurve = !pForm->mo->showCurve;
            break;
            
        case Key_E:
            pForm->mo->showEdge = !pForm->mo->showEdge;
            break;

        case Key_F:
            if(e->state()&&ShiftButton) {
                pForm->mo->showFrame = !pForm->mo->showFrame;
            }
            else {
                pForm->mo->showFace = !pForm->mo->showFace;
            }
            break;

        case Key_G:
            if(e->state()&&ShiftButton) {
            }
            else {
                pForm->mo->showGap = !pForm->mo->showGap;
            }
            break;



		case Key_K:
            break;

        case Key_L:
            pForm->mo->showLabels = !pForm->mo->showLabels; 
            pForm->notifyOGLWidgets();
            break;

        case Key_N:
            pForm->mo->showNormals = !pForm->mo->showNormals;
            break;

        case Key_P:
            pForm->mo->showPalette = !pForm->mo->showPalette;
            break;

        case Key_Q:
            pForm->calbak_Swap_Frames();
            break;            

        case Key_R:
            this->resetApp();
            break;

        case Key_S:
            break;

        case Key_T:
            if(e->state() && ControlButton) {
                pForm->mo->showTSpace = !pForm->mo->showTSpace ;
            }
            break;

        case Key_W:
            pForm->mo->qwhichQuatComponent = SHOWXYZ;
			pForm->updateObject();
            break;

        case Key_X:
            pForm->mo->qwhichQuatComponent = SHOWWYZ;
			pForm->updateObject();
            break;
		
        case Key_Y:
            pForm->mo->qwhichQuatComponent = SHOWWXZ;
			pForm->updateObject();
            break;

        case Key_Z:
            pForm->mo->qwhichQuatComponent = SHOWWXY;
			pForm->updateObject();
            break;
            
        case Key_1:
			pForm->mo->showColorCoded = CODE_SOLID_COLOR;
            break;
        case Key_2:
			pForm->mo->showColorCoded = CODE_CURVATURE;
			pForm->mo->computeCurveProperties();
            break;
        case (Key_3):
			pForm->mo->showColorCoded = CODE_TORSION;
			pForm->mo->computeCurveProperties();
            break;
        case (Key_4):
            break;
            
        case 27 :
        case Key_Escape:
            //if(mb.exec() == QMessageBox::Yes)
                pForm->exitApp();
            break;

        default:
            break;
    }

    pForm->stateChange();
    updateGL();
	//pForm->notifyOGLWidgets();
}

//#RENDER
void OGLWidgetMain::paintGL					( )
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	pForm->stateChange();
	glPushMatrix();
		glTranslatef(Cx, Cy, 0);
		glScalef(m_viewScale, m_viewScale, m_viewScale);		
        pForm->mo->display();
	glPopMatrix();
	if(pForm->mo->showOnScreenHelp)
		showOnScreenText();
    glPushMatrix();
   	if(pForm->mo->showPalette)
		drawPalette();
    glPopMatrix();
	//if(pForm->mo->flag_update_track_ring) {
	//	pForm->updateForm();
	//	pForm->mo->flag_update_track_ring = 0;
	//}
	//printf("key status:\n");
	//printf("alt = %d, ctrl = %d, shift = %d\n",pForm->mo->flag_keypress_ALT,pForm->mo->flag_keypress_CTRL,pForm->mo->flag_keypress_SHIFT);


	pForm->updateForm();
}

void OGLWidgetMain::renderAxes				( void )
{
    double len = 0.5;
    double rad = 0.025;
    
    GLUquadricObj *qobj;
    qobj = gluNewQuadric();

    glPushAttrib(GL_CURRENT_BIT | GL_LIGHTING_BIT);
      glDisable(GL_LIGHTING);
      glPushMatrix();
        glTranslatef(0.0,0.0,0.0);
        glColor3f(0.0, 0.0, 1.0);
        glRotatef(-90,1,0,0);
        gluQuadricDrawStyle(qobj, GLU_FILL);
        gluCylinder(qobj, rad, rad, len, 16, 16);
      glPopMatrix();
      glPushMatrix();
        glTranslatef(0.0,0.0,0.0);
        glColor3f(0.0, 1.0, 0.0);
        glRotatef(90,0,1,0);
        gluQuadricDrawStyle(qobj, GLU_FILL);
        gluCylinder(qobj, rad, rad, len, 16, 16);
      glPopMatrix();
      glPushMatrix();
        glTranslatef(0.0,0.0,0.0);
        glColor3f(1.0, 0.0, 0.0);
        glRotatef(0,0,0,1);
        gluQuadricDrawStyle(qobj, GLU_FILL);
        gluCylinder(qobj, rad, rad, len, 16, 16);
      glPopMatrix();
    glPopAttrib();
    
}


//#UTILITIES
void OGLWidgetMain::text					( char* string, void *font ) {
  char* p;
  for(p=string;*p;p++) {
    glutBitmapCharacter(font,*p);
  }
}

void OGLWidgetMain::showOnScreenText		( ) {
	double	xpos=0.0;
	double	ypos=0.0;
	double	delta=0.2;
	void	*qfont;
    
    glPushAttrib(GL_CURRENT_BIT | GL_LIGHTING_BIT);
    glDisable(GL_LIGHTING);
    
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
        glLoadIdentity();
        glMatrixMode(GL_PROJECTION);
        glPushMatrix();
        glLoadIdentity();
        gluOrtho2D(-1.2,1.2,-1.2,4.2);

        glMatrixMode(GL_MODELVIEW);
        glDisable(GL_LIGHTING);

        xpos=-1.0;
        ypos=-0.8;
        
		if(pForm->mo->objectID == OBJCURVE) {
			glColor3f(0.0f,0.0f,0.7f);
			if(pForm->mo->whichCurve == OBJKNOT) {

				if(pForm->swapFrames)
					qfont = GLUT_BITMAP_HELVETICA_10;
				else if(!pForm->swapFrames)
					qfont = GLUT_BITMAP_HELVETICA_18;

				sprintf(qstr,"Torus");
				glRasterPos2f(xpos,ypos);
				text(qstr,qfont);
				if(!pForm->swapFrames) {
					switch(pForm->mo->whichFrame) {
						case FRENETSERRET:
							sprintf(qstr,"Frame: Frenet-Serret");
							break;
						case PARALLELTRANSPORT:
							sprintf(qstr,"Frame: Parallel Transport");
							break;
						case GEODESICREFERENCE:
							sprintf(qstr,"Frame: Geodesic Reference");
							break;
						default:
							break;
					}
					ypos-=delta;
					glRasterPos2f(xpos,ypos);
					text(qstr,qfont);
				}
			}
			else if(pForm->mo->whichCurve == OBJSPLINE) {
				if(pForm->swapFrames)
					qfont = GLUT_BITMAP_HELVETICA_10;
				else if(!pForm->swapFrames)
					qfont = GLUT_BITMAP_HELVETICA_18;
				sprintf(qstr,"Editable Splines");
				glRasterPos2f(xpos,ypos);
				text(qstr,qfont);

				//if(pForm->mo->flag_keypress_SHIFT) {
				//	//sprintf(qstr,"Shift and Vertical-mouse-drag: Translate in z-direction");
				//	ypos-=delta;
				//	glRasterPos2f(xpos,ypos);
				//	text(qstr,qfont);
				//}
				//else if(pForm->mo->flag_keypress_CTRL) {
				//	sprintf(qstr,"Control + Mouse-drag: Rotation");
				//	ypos-=delta;
				//	glRasterPos2f(xpos,ypos);
				//	text(qstr,qfont);
				//}
				if(!pForm->swapFrames) {
					glColor3f(0.0f,0.0f,0.7f);
					ypos-=delta;
					sprintf(qstr,"Quat distance: %f, angle: %f",pForm->mo->curveQuatDistance,pForm->mo->curveQuatAngle);
					glRasterPos2f(xpos,ypos);
					text(qstr,GLUT_BITMAP_HELVETICA_18);
				}
			}
		}
		else if( pForm->mo->objectID == OBJSURFACE ) {
			glColor3f(0.0f,0.0f,0.7f);

			if(pForm->swapFrames || pForm->swapFrames2)
				qfont = GLUT_BITMAP_HELVETICA_12;
			else if(!pForm->swapFrames && !pForm->swapFrames2)
				qfont = GLUT_BITMAP_HELVETICA_18;

			sprintf(qstr,"Torus");
			glRasterPos2f(xpos,ypos);
			text(qstr,qfont);
		}
        glMatrixMode(GL_PROJECTION);   
        glPopMatrix();
        glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glPopAttrib();
}

int OGLWidgetMain::saveScreenAsBMP			( )
{
	static int	counter = 1;
	char		fname[100];
	
	//# Make GL Context current
	printf("Main: makeCurrent()\n");
	makeCurrent();

	////# Copy from OpenGL screen buffer
	QImage *tempImage = new QImage( grabFrameBuffer() );

	if ( !tempImage ) {
		fprintf(stderr,"Error! Failed to allocate memory for image\n");
		return false;
	}

 //   
 //   /* Open the file */
	if(pForm->mo->whichFrame == FRENETSERRET)
		sprintf(fname,"./snapshots/curve_%d_%d_torus_knot_frenet%01d.bmp",pForm->mo->m,pForm->mo->n,counter);
	else if(pForm->mo->whichFrame == PARALLELTRANSPORT)
		sprintf(fname,"./snapshots/curve_%d_%d_torus_knot_parelltrans%01d.bmp",pForm->mo->m,pForm->mo->n,counter);

	printf("name = %s\n",fname);

	if ( !tempImage->save( QString(fname), "BMP") ) {
		fprintf(stderr,"Error! Could not save BMP file...\n");
		return false;
	}
	else {
		printf("Saved! Writing out file: %s\n",fname);
		counter++;
	}
	 
	//# Clean memory
	delete tempImage;

	return true;

}

void OGLWidgetMain::processHits				( GLint hits, GLuint buffer[] )
{
    
    GLuint	*ptr = NULL;
	GLuint	names = 0;

    int i,j;
    
    ptr= (GLuint *) buffer;
    
    if(hits ==0){
        litVertex = -1;
		pForm->mo->selected_point = -1;
    }
    
    
    for(i=0; i< hits; i++){
        names = *ptr;
        ptr++;
        ptr++;//don't need z1
        ptr++;//don't need z2
        if(i==0){
            litVertex = *ptr;
        }
        else if(i==1 && zCoord[litVertex] > *ptr){
            litVertex = *ptr;
        }
        for (j = 0; j < (signed)names; j++) {	/*  for each name */
            ptr++;
        }
		//printf("selected= %d\n",litVertex);
		pForm->mo->selected_point = litVertex;
    }
}

void OGLWidgetMain::mousePickVertex			( int x, int y )
{
	
    GLuint selectBuf[BUFSIZE];
    GLint hits;
    GLint viewport[4];

    //get the dimensions of the viewport
    glGetIntegerv(GL_VIEWPORT,viewport);
    
    glSelectBuffer(BUFSIZE,selectBuf);
    (void) glRenderMode(GL_SELECT);
  
    glInitNames();
    //push an initial name onto the stack so we can use LoadName() later
    glPushName(0);
    
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();

    //center the picking region around the mouse location
    gluPickMatrix((GLdouble)x, (GLdouble)(viewport[3]-y),10,10,viewport);
    
    glFrustum(xMin, xMax, yMin, yMax, zNear, zFar);
    
    // WARNING: change to GL_MODELVIEW before drawing in GL_SELECT mode
    // otherwise unpredictable rendering will occur.
    glMatrixMode(GL_MODELVIEW);

    pForm->mo->displayPoints (GL_SELECT);
	//fwin2_pForm->mo->showQuaternionCurve_PickingMode(GL_SELECT);


    glMatrixMode(GL_PROJECTION);
    glPopMatrix();

    // WARNING: change to GL_MODELVIEW before leaving the routine
    // otherwise unpredictable rendering will occur.
    glMatrixMode(GL_MODELVIEW);
    hits=glRenderMode(GL_RENDER);

    //process the hits
    processHits(hits,selectBuf);
    updateGL();
}

void OGLWidgetMain::addPoint				( int x, int y) 
{
    GLdouble	objx, objy, objz;
    GLint		viewport[4],winHeight;
    GLdouble	mvmatrix[16], projmatrix[16];

    //y=0 is at bottom of screen here
    glGetDoublev(GL_MODELVIEW_MATRIX, mvmatrix);
    glGetDoublev(GL_PROJECTION_MATRIX, projmatrix);
    glGetIntegerv(GL_VIEWPORT,viewport);
    winHeight = viewport[3];

    if(gluUnProject((GLdouble)x,(GLdouble)y,0.625, mvmatrix,projmatrix,viewport,&objx,&objy,&objz) == GL_FALSE){
        printf("gluUnProject() didn't work in addPoint()\n");
    }
    else{
		if(pForm->mo->objectID == OBJCURVE && pForm->mo->whichCurve == OBJSPLINE) {
			pForm->mo->ctrlPntList[pForm->mo->numCtrlPoints].p3.d[0] = objx;
			pForm->mo->ctrlPntList[pForm->mo->numCtrlPoints].p3.d[1] = objy;
			pForm->mo->ctrlPntList[pForm->mo->numCtrlPoints].p3.d[2] = objz;
			pForm->mo->numCtrlPoints++;
			printf("Added Control-Point: %f, %f, %f, Total Control-points: %d\n",objx, objy, objz,pForm->mo->numCtrlPoints);
			pForm->notifyOGLWidgets();
		}
	}
	pForm->updateObject();
	pForm->notifyOGLWidgets();
}

void OGLWidgetMain::texLoadTexture			( const char *texFileName )
{
}
//*********************************************//
//
//*********************************************//
void OGLWidgetMain::drawPalette_2								( void ) 
{
	int i; 
	double p[3];
	double x0, x1, y0, y1, dy;
  
	x0 = 0.05; x1= 0.07;
	y0 = 0.2; y1= 0.8; dy = (y1-y0) / 255.0;

	glPushAttrib(GL_LIGHTING_BIT);
	glDisable(GL_LIGHTING);

    glPushMatrix();
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	    glLoadIdentity();
	    glOrtho(0.0, 1.0, 0.0, 1.0, -1.0, 1.0);

	    glMatrixMode(GL_MODELVIEW);
	    glPushMatrix();
	            glLoadIdentity();
		        glBegin(GL_TRIANGLE_STRIP);
			        for(i=0; i<256; i++) { 
				        p[0] = x0;
				        p[1] = y0 + i * dy;;
				        p[2] = 0.0;
				        glColor4fv(pForm->mo->palette[i]);
				        glVertex3dv(p);
				        p[0] = x1;
				        glVertex3dv(p);
			        }
		        glEnd();
	    glPopMatrix();

	    glMatrixMode(GL_PROJECTION);
	glPopMatrix();
    glPopMatrix();
	glEnable(GL_LIGHTING);
	glPopAttrib();
}

void OGLWidgetMain::drawPalette             ( void )
{
    int i =0;
    double p[3];
	double x0, x1, y0, y1, dy;
  
	x0 = 0.05; x1= 0.07;
	y0 = 0.2; y1= 0.8; dy = (y1-y0) / 255.0;

    glPushAttrib(GL_CURRENT_BIT | GL_LIGHTING_BIT);
        glDisable(GL_LIGHTING);
        glMatrixMode(GL_MODELVIEW);
        glPushMatrix();
            glLoadIdentity();
            glMatrixMode(GL_PROJECTION);
            glPushMatrix();
            glLoadIdentity();
            //gluOrtho2D(-1.2,1.2,-1.0,1.0);
            glOrtho(0.0, 1.0, 0.0, 1.0, -1.0, 1.0);

            glMatrixMode(GL_MODELVIEW);
            glDisable(GL_LIGHTING);

	    glPushMatrix();
	            glLoadIdentity();
		        glBegin(GL_TRIANGLE_STRIP);
			        for(i=0; i<256; i++) { 
				        p[0] = x0;
				        p[1] = y0 + i * dy;;
				        p[2] = 0.0;
				        glColor4fv(pForm->mo->palette[i]);
				        glVertex3dv(p);
				        p[0] = x1;
				        glVertex3dv(p);
			        }
		        glEnd();
	    glPopMatrix();


            glMatrixMode(GL_PROJECTION);   
            glPopMatrix();
            glMatrixMode(GL_MODELVIEW);
        glPopMatrix();
    glPopAttrib();

}