#ifndef _OGLWIDGETMAIN_
#define _OGLWIDGETMAIN_

#include <qgl.h>
#include "all.h"

class OGLWidgetMain : public QGLWidget 
{
public:
	OGLWidgetMain( QWidget* parent, const char* name, QWidget* parentForm );
	~OGLWidgetMain ( );

public: //VARIABLES
	// world center
	GLfloat			XC, YC, ZC;					//
    int				X,	Y,	dX, dY;				//
    GLfloat			Cx, Cy, Cz;					//
    double			m_viewScale;				//
    int				main_height, main_width;	//
    int     		enable_picking;				//
    float			xCoord[MAX_POINTS];			//
    float			yCoord[MAX_POINTS];			//
    float			zCoord[MAX_POINTS];			//

	// lighting
    GLfloat 		global_light0[4];			//

	// View-port parameters
    float			xMin;						//
    float			xMax;						//
    float			yMin;						//
    float			yMax;						//
    float			zNear;						//
    float			zFar;						//

	// mouse event data handlers
    float			startY;						//
    int				xBegin, xNext;				//
    int				yBegin, yNext;				//
	int				modkey;						//
    int				button;						//
    int				mouseModifiers;				//
	int				mouseButtons;				//

	// mouse: picking data handlers
	int				litVertex;					//
    int				movingPoint;				//
    int				MouseModifiers;				//


public: 

	/* ADMINISTRATION */
	//window operations
	void			initializeGL				( void );						//
	void			init						( void );						//
	void			initLighting				( void );						//
	void			paintGL						( void );						//
	void			resizeGL					( int wd, int ht ); 			//
	void			resetApp					( void );						//
	void			showOnScreenText			( void );						//
	void			text						( char* string, void *font );	//
	void			renderAxes					( void );						//
	int				saveScreenAsBMP				( void );						//
	void			addPoint					( int x, int y);				//
    void            drawPalette                 ( void );
    void            drawPalette_2                 ( void );


	//event handlers
    void			keyPressEvent				( QKeyEvent *e );				//			
	void			mousePressEvent				( QMouseEvent *e );				//
	void			mouseReleaseEvent			( QMouseEvent *e );				//
	void			moveTransformedCoordinate	( float x, float y );			//
	void			mouseMoveEvent				( QMouseEvent *e );				//
	void			mouseDoubleClickEvent		( QMouseEvent *e );				//
	void			processHits					( GLint hits, GLuint buffer[] );
	void			mousePickVertex				( int x, int y );
	
	//texture mgmt
	void			texLoadTexture				( const char *texFileName );

};


#endif
