#include "objectCurve.h"
#include "QuaternionSet.h"

//global declarations
MathObject	*mo2;
char		obj_qstr[128];
static		GLUquadricObj *qobjCYL, *qobjSPH;

//Rings structs
int MAX_RING_PNTS = 300;
Vertex  **prevList;
Vertex	**firstList;
Vertex	**currList;

//# INITIALIZE
void initializeApplication ( MathObject *mathobjRef )
{
//	int	i =	0;
	mo2	= mathobjRef;
	
	mo2->objectID =	OBJCURVE;

	//@ viewing options
	mo2->showCurve				= 1;
	mo2->showTSpace				= 0;
	mo2->whichFrame				= FRENETSERRET;
	mo2->qfont					= GLUT_BITMAP_HELVETICA_10;

	//@ quaternion viewing options
	mo2->qshowSphere			= 1;
	mo2->qwhichQuatComponent	= SHOWXYZ;
	mo2->qshowReflectedPoints	= 0;
	mo2->qshowQuatRings			= 1;
	mo2->trackingRing			= -1;

	//curve params
	mo2->showControlPoints		= 1;
	mo2->whichSpline			= CATROM;
	mo2->param_spline_increment = 0.05;

	//knot params
	mo2->showGap				= 0;
	mo2->m						= 2;
	mo2->n						= 3;
	mo2->a						= 0.3;
	mo2->b						= 0.4;
	mo2->r						= 0.8;
	mo2->lock_a_b				= 0;
	mo2->flag_update_track_ring = 1;

//	mo2->pntList = (Vertex*) my_malloc(sizeof(Vertex)*MAX_POINTS);
//	for(i=0; i<MAX_POINTS; i++)	{
//		mo2->pntList->p3.d[0] =	0.0;
//		mo2->pntList->p3.d[1] =	0.0;
//		mo2->pntList->p3.d[2] =	0.0;
//	}
//	
//	mo2->selectedPoint	= 0;
//	mo2->increment		= 0.05;
//	mo2->numPoints		= 0;
//
//	mo2->showAxes		= 1;
//	mo2->showCurve		= 1;
//	mo2->showFrame		= 0;
//	mo2->showFace		= 1;
//	mo2->showEdge		= 0;
//	mo2->showLabels		= 1;
//	mo2->showMesh		= 0;
//	mo2->showNormals	= 0;
//	mo2->showQuatMap	= 1;
//	mo2->showViewWYZ	= 1;
//	mo2->TORUS_PNTS		= 50;
//	mo2->TORUS_STPS		= 30;
//	mo2->showTSpace		= 0;
//	mo2->whichFrame	  =	PARALLELTRANSPORT;
////	  	mo2->whichFrame		= FRENETSERRET;
//	mo2->whichQuatFrame	= PARALLELTRANSPORT;
//	mo2->whoCommandsMainWin = MAIN_WINDOW;
//
//	// quaternion map
//	mo2->flag_edit_quatmap = 0;
//	mo2->qfont			= GLUT_BITMAP_HELVETICA_12;
//	mo2->kflip			= 1;
//	mo2->qshowAxes		= 1;
//	mo2->qshowFrame		= 0;
//	mo2->qshowFace		= 1;
//	mo2->qshowEdge		= 0;
//	mo2->qshowNormals	= 0;
//	mo2->qwhichQuatComponent = SHOWXYZ;
//	mo2->qshowQuatRings	= 0;
//	mo2->qshowCloudPoints=0;
//	mo2->qshowSphere	= 1;
//
//	// quatenrion ring
//	mo2->numOfRings		= 4;	
//	mo2->rshowAxes		= 1;
//	mo2->rshowCurve		= 0;
//	mo2->rshowEdge		= 0;
//	mo2->rshowFace		= 1;
//	mo2->rshowFrame		= 0;
//
//	mo2->m			= 2;
//	mo2->n			= 2;
//	mo2->r			= 0.8;
//	mo2->a			= 0.4;
//	mo2->b			= 0.5;
//	mo2->lock_a_b	= 0;
//	mo2->startTheta	= 0.0;
//	mo2->leave_gap				= 1;
//	mo2->go_around_twice		= 0;
//	mo2->flag_end_rings_match	= 0;
//	mo2->flag_track_ring		= 0;
//	mo2->flag_update_track_ring = 1;
//	mo2->trackingRing			= 5;
//	mo2->trackingRingTheta		= 0.0;
//
//	mo2->fgcolor[0]	= 0.1; 
//	mo2->fgcolor[1]	= 0.37;
//	mo2->fgcolor[2]	= 0.22;
//	
//	mo2->qset		= new QuaternionSet();
//
//	initKnot();
//	
//	qobjCYL		= gluNewQuadric();
//	qobjSPH		= gluNewQuadric();
//
//	//Ring structs
//	firstList = (Vertex**) my_malloc(sizeof(Vertex)*MAX_RING_PNTS);
//	for(i=0;i<MAX_RING_PNTS;i++)
//		firstList[i] = (Vertex*) my_malloc(sizeof(Vertex));
//
//	prevList = (Vertex**) my_malloc(sizeof(Vertex)*500);
//	for(i=0;i<MAX_RING_PNTS;i++)
//		prevList[i] = (Vertex*) my_malloc(sizeof(Vertex));
//
//	currList = (Vertex**) my_malloc(sizeof(Vertex)*MAX_RING_PNTS);
//	for(i=0;i<MAX_RING_PNTS;i++)
//		currList[i] = (Vertex*) my_malloc(sizeof(Vertex));
//
//	for(i=0;i<MAX_POINTS;i++) 
//		mo2->rthetaList[i] = 0.0;

}

void initCurve ( void )
{
	int	i=0;
	//int	j=0;
	//int	k=0;

	printf("INIT structs... initCurve()\n");
	
	//@ init all lists
	for(i=0; i<MAX_POINTS; i++)	{
		
		mo2->numPoints =				0;
		mo2->numCtrlPoints =			0;

		mo2->pntList[i].p3.d[0] =		0.0;
		mo2->pntList[i].p3.d[1] =		0.0;
		mo2->pntList[i].p3.d[2] =		0.0;

		mo2->ctrlPntList[i].p3.d[0] =	0.0;
		mo2->ctrlPntList[i].p3.d[1] =	0.0;
		mo2->ctrlPntList[i].p3.d[2] =	0.0;

		mo2->TangList[i].p3.d[0] =		0.0;
		mo2->TangList[i].p3.d[1] =		0.0;
		mo2->TangList[i].p3.d[2] =		0.0;

		mo2->dTangList[i].p3.d[0] =		0.0;
		mo2->dTangList[i].p3.d[1] =		0.0;
		mo2->dTangList[i].p3.d[2] =		0.0;

		mo2->basisRList[i].p3.d[0] =	0.0;
		mo2->basisRList[i].p3.d[1] =	0.0;
		mo2->basisRList[i].p3.d[2] =	0.0;

		mo2->basisSList[i].p3.d[0] =	0.0;
		mo2->basisSList[i].p3.d[1] =	0.0;
		mo2->basisSList[i].p3.d[2] =	0.0;

		mo2->quatList[i].r =			0.0;
		mo2->quatList[i].i =			0.0;
		mo2->quatList[i].j =			0.0;
		mo2->quatList[i].k =			0.0;

		mo2->refquatList[i].r =			0.0;
		mo2->refquatList[i].i =			0.0;
		mo2->refquatList[i].j =			0.0;
		mo2->refquatList[i].k =			0.0;

		mo2->ptQuatList[i].r =			0.0;
		mo2->ptQuatList[i].i =			0.0;
		mo2->ptQuatList[i].j =			0.0;
		mo2->ptQuatList[i].k =			0.0;

		mo2->fsQuatList[i].r =			0.0;
		mo2->fsQuatList[i].i =			0.0;
		mo2->fsQuatList[i].j =			0.0;
		mo2->fsQuatList[i].k =			0.0;

		mo2->ptRBasis[i].p3.d[0] =		0.0;
		mo2->ptRBasis[i].p3.d[1] =		0.0;
		mo2->ptRBasis[i].p3.d[2] =		0.0;

		mo2->ptSBasis[i].p3.d[0] =		0.0;
		mo2->ptSBasis[i].p3.d[1] =		0.0;
		mo2->ptSBasis[i].p3.d[2] =		0.0;

		mo2->fsRBasis[i].p3.d[0] =		0.0;
		mo2->fsRBasis[i].p3.d[1] =		0.0;
		mo2->fsRBasis[i].p3.d[2] =		0.0;

		mo2->fsSBasis[i].p3.d[0] =		0.0;
		mo2->fsSBasis[i].p3.d[1] =		0.0;
		mo2->fsSBasis[i].p3.d[2] =		0.0;

	}
}
void initKnot ( void )
{
	mo2->m = 2;
	mo2->n = 3;
	mo2->a = 0.3;
	mo2->b = 0.5;
	mo2->r = 0.8;
	mo2->increment = 0.05;

}
void cleanupKnot ( void	)
{
}

//# UTILITIES
void copyQuatList ( void )	
{
	int	i =	0;
	int limit = 0;

	if(mo2->flag_curve_closed)
		limit = mo2->numPoints;
	else
		limit = mo2->numPoints-2;

	for(i=0; i<limit; i++) {
		if(mo2->whichFrame == FRENETSERRET) {
			mo2->refquatList[i].r = -mo2->fsQuatList[i].r;
			mo2->refquatList[i].i = -mo2->fsQuatList[i].i;
			mo2->refquatList[i].j = -mo2->fsQuatList[i].j;
			mo2->refquatList[i].k = -mo2->fsQuatList[i].k;
		}
		else if(mo2->whichFrame == PARALLELTRANSPORT) {
			mo2->refquatList[i].r = -mo2->ptQuatList[i].r;
			mo2->refquatList[i].i = -mo2->ptQuatList[i].i;
			mo2->refquatList[i].j = -mo2->ptQuatList[i].j;
			mo2->refquatList[i].k = -mo2->ptQuatList[i].k;
		}
	}
}


void getQuatComp ( int whichQuatComponent, quaternion* q, double* qvec) {
	switch(whichQuatComponent) {

		case SHOWXYZ:
			qvec[0] = q->i;
			qvec[1] = q->j;
			qvec[2] = q->k;
			break;

		case SHOWWYZ:
			qvec[0] = q->r;
			qvec[1] = q->j;
			qvec[2] = q->k;
			break;
		
		case SHOWWXY:
			qvec[0] = q->r;
			qvec[1] = q->i;
			qvec[2] = q->j;
			break;

		case SHOWWXZ:
			qvec[0] = q->r;
			qvec[1] = q->i;
			qvec[2] = q->k;
			break;

		default:
			break;
		}	
}

void getSegmentColor(int i,	double *ccolor)	{

	switch(i) {
		case 0:
			ccolor[0] =	0.2; ccolor[1]	= 0.55; ccolor[2] = 0.35;
			break;
		case 1:
			ccolor[0] =	0.75; ccolor[1]	= ccolor[2]	= 0.2;
			break;
		case 2:
			ccolor[1] =	0.75; ccolor[0]	= ccolor[2]	= 0.2;
			break;
		case 3:
			ccolor[2] =	0.75; ccolor[1]	= ccolor[0]	= 0.2;
			break;
		case 4:
			ccolor[0] =	0.0; ccolor[1] = ccolor[2] = 0.75;
			break;
		case 5:
			ccolor[2] =	0.0; ccolor[1] = ccolor[0] = 0.75;
			break;
		case 6:
			ccolor[1] =	0.0; ccolor[0] = ccolor[2] = 0.75;
			break;
		case 7:
			ccolor[0] =	ccolor[1] =	ccolor[2] =	0.2;
			break;
		case 8:
			ccolor[0] =	ccolor[1] =	ccolor[2] =	0.4;
			break;
		case 9:
			ccolor[0] =	ccolor[1] =	ccolor[2] =	0.6;
			break;
		case 10:
			ccolor[0] =	ccolor[1] =	ccolor[2] =	1.0;
			break;
		case 11:
			ccolor[2] =	0.0; ccolor[1] = ccolor[0] = 1.0;
			break;
		case 12:
			ccolor[2] =	0.2; ccolor[1] = 0.5; ccolor[0]	= 1.0; 
			break;

		default:
			ccolor[0] =	ccolor[1] =	ccolor[2] =	1.0;
			break;
	}
}
void reflect_QuatList ( void )	
{
	int	i =	0;

	for(i=0;i<mo2->numPoints;i++) {
		//printf("[%d] q =  %f, %f ,%f \n",i,mo2->quatList[i].r,mo2->quatList[i].i,mo2->quatList[i].j);
		/*quatCopy(&(mo2->quatList[i]),r);
		mo2->quatList[i].r = -r->r;
		mo2->quatList[i].i = -r->i;
		mo2->quatList[i].j = -r->j;
		mo2->quatList[i].k = -r->k;*/
		switch(mo2->qwhichQuatComponent) {
			case SHOWXYZ:
				mo2->pntList[i].p3.d[0]	= -mo2->quatList[i].i;
				mo2->pntList[i].p3.d[1]	= -mo2->quatList[i].j;
				mo2->pntList[i].p3.d[2]	= -mo2->quatList[i].k;
				break;
			case SHOWWYZ:
				mo2->pntList[i].p3.d[0]	= -mo2->quatList[i].r;
				mo2->pntList[i].p3.d[1]	= -mo2->quatList[i].j;
				mo2->pntList[i].p3.d[2]	= -mo2->quatList[i].k;
				break;
			case SHOWWXZ:
				mo2->pntList[i].p3.d[0]	= -mo2->quatList[i].r;
				mo2->pntList[i].p3.d[1]	= -mo2->quatList[i].i;
				mo2->pntList[i].p3.d[2]	= -mo2->quatList[i].k;
				break;
			case SHOWWXY:
				mo2->pntList[i].p3.d[0]	= -mo2->quatList[i].r;
				mo2->pntList[i].p3.d[1]	= -mo2->quatList[i].i;
				mo2->pntList[i].p3.d[2]	= -mo2->quatList[i].j;
				break;
			default:
				break;
		}
	}
}


void stext(char* string) {
  char* p;
  for(p=string;*p;p++) {
    glutBitmapCharacter((void*)mo2->qfont,*p);
  }
}

//# COMPUTATIONS
void computeSplineEquation ( void )
{
    int    i	 = 0;
    double t	 = 0.0;
    int    count = 0;
    int    step	 = 0;
    
    Vertex P0,P1,P2,P3;
    Vertex *pt;

    pt = (Vertex*) malloc(sizeof(Vertex));

	if(mo2->whichSpline!=NOSPLINE) {

		//@ Define spline parameter
		if(mo2->whichSpline==BEZIER)
			step=3;
		else if(mo2->whichSpline==CATROM || mo2->whichSpline==BSPLINE)
			step=1;
	    
		mo2->numPoints = 0;

		//@ Compute spline points and derivatives
		for(i=0; i<mo2->numCtrlPoints-3; i+=step) {
			t=0;
			P0.p3.d[0] = mo2->ctrlPntList[i].p3.d[0];
			P0.p3.d[1] = mo2->ctrlPntList[i].p3.d[1];
			P0.p3.d[2] = mo2->ctrlPntList[i].p3.d[2];
	        
			P1.p3.d[0] = mo2->ctrlPntList[i+1].p3.d[0];
			P1.p3.d[1] = mo2->ctrlPntList[i+1].p3.d[1];
			P1.p3.d[2] = mo2->ctrlPntList[i+1].p3.d[2];

			P2.p3.d[0] = mo2->ctrlPntList[i+2].p3.d[0];
			P2.p3.d[1] = mo2->ctrlPntList[i+2].p3.d[1];
			P2.p3.d[2] = mo2->ctrlPntList[i+2].p3.d[2];

			P3.p3.d[0] = mo2->ctrlPntList[i+3].p3.d[0];
			P3.p3.d[1] = mo2->ctrlPntList[i+3].p3.d[1];
			P3.p3.d[2] = mo2->ctrlPntList[i+3].p3.d[2];

			while(t<=1.0) {

				// compute interpolated spline-point
				P( P0, P1, P2, P3, pt, t, mo2->whichSpline );
				mo2->pntList[count].p3.d[0] = pt->p3.d[0];
				mo2->pntList[count].p3.d[1] = pt->p3.d[1];
				mo2->pntList[count].p3.d[2] = pt->p3.d[2];

				// compute tangent-first-derivative
				//computeSplineFirstDerivative(P0,P1,P2,P3,pt,t,whichSpline);
				//TangList[count].p3.d[0] = pt->p3.d[0];
				//TangList[count].p3.d[1] = pt->p3.d[1];
				//TangList[count].p3.d[2] = pt->p3.d[2];

				// compute tangent-second-derivative
				//computeSplineSecondDerivative(P0,P1,P2,P3,pt,t,whichSpline);
				//dTangList[count].p3.d[0] = pt->p3.d[0];
				//dTangList[count].p3.d[1] = pt->p3.d[1];
				//dTangList[count].p3.d[2] = pt->p3.d[2];

				t = t + mo2->param_spline_increment;
				count++;
			}

			//// compute tangent-first-derivative on last point on curve
			//computeSplineFirstDerivative(P0,P1,P2,P3,pt,1.0,whichSpline);
			//TangList[count].p3.d[0] = pt->p3.d[0];
			//TangList[count].p3.d[1] = pt->p3.d[1];
			//TangList[count].p3.d[2] = pt->p3.d[2];

			//// compute tangent-second-derivative on last point on curve
			//computeSplineSecondDerivative(P0,P1,P2,P3,pt,1.0,whichSpline);
			//dTangList[count].p3.d[0] = pt->p3.d[0];
			//dTangList[count].p3.d[1] = pt->p3.d[1];
			//dTangList[count].p3.d[2] = pt->p3.d[2];
		}

		if(mo2->numCtrlPoints > 3) {
			// add last point to curve
			if(mo2->whichSpline==BEZIER) {
				mo2->pntList[count].p3.d[0] = P3.p3.d[0];
				mo2->pntList[count].p3.d[1] = P3.p3.d[1];
				mo2->pntList[count].p3.d[2] = P3.p3.d[2];
				count++;
			}
			else if(mo2->whichSpline==CATROM) {
				mo2->pntList[count].p3.d[0] = P2.p3.d[0];
				mo2->pntList[count].p3.d[1] = P2.p3.d[1];
				mo2->pntList[count].p3.d[2] = P2.p3.d[2];
				count++;
			}
		}
		mo2->numPoints = count;
	}
	else {
		step = 1;
		//@ Compute spline points and derivatives
		for(i=0; i<mo2->numCtrlPoints-1; i+=step) {
			if(i>0)
				count--;

			t=0.0;
			P0.p3.d[0] = mo2->ctrlPntList[i].p3.d[0];
			P0.p3.d[1] = mo2->ctrlPntList[i].p3.d[1];
			P0.p3.d[2] = mo2->ctrlPntList[i].p3.d[2];
	        
			P1.p3.d[0] = mo2->ctrlPntList[i+1].p3.d[0];
			P1.p3.d[1] = mo2->ctrlPntList[i+1].p3.d[1];
			P1.p3.d[2] = mo2->ctrlPntList[i+1].p3.d[2];	

			while(t<=1.0) {

				pt->p3.d[0] = P1.p3.d[0]*t + (1-t)*P0.p3.d[0];
				pt->p3.d[1] = P1.p3.d[1]*t + (1-t)*P0.p3.d[1];
				pt->p3.d[2] = P1.p3.d[2]*t + (1-t)*P0.p3.d[2];

				mo2->pntList[count].p3.d[0] = pt->p3.d[0];
				mo2->pntList[count].p3.d[1] = pt->p3.d[1];
				mo2->pntList[count].p3.d[2] = pt->p3.d[2];
				t = t + mo2->param_spline_increment;
				count++;
			}
		}
		mo2->numPoints = count;
	}
}
void P ( Vertex P0, Vertex P1, Vertex P2, Vertex P3 , Vertex *P, double t, int currentSpline )
{
    if(currentSpline==BEZIER) {

        /* Parametric equation of Bezier Spline */
        /*
          P(t) = (1-t)^3.P0 + 3.t.(1-t)^2.P1 + 3.t^2.(1-t).P2 + t^3.P3
        */
        P->p3.d[0] = pow((1-t),3.0)*P0.p3.d[0] + 3*t*pow((1-t),2.0)*P1.p3.d[0] + 3*pow(t,2.0)*(1-t)*P2.p3.d[0] + pow(t,3.0)*P3.p3.d[0];
        P->p3.d[1] = pow((1-t),3.0)*P0.p3.d[1] + 3*t*pow((1-t),2.0)*P1.p3.d[1] + 3*pow(t,2.0)*(1-t)*P2.p3.d[1] + pow(t,3.0)*P3.p3.d[1];
        P->p3.d[2] = pow((1-t),3.0)*P0.p3.d[2] + 3*t*pow((1-t),2.0)*P1.p3.d[2] + 3*pow(t,2.0)*(1-t)*P2.p3.d[2] + pow(t,3.0)*P3.p3.d[2];
    }
    else if(currentSpline==CATROM) {
        
        /* Parametric equation of Catmull-Rom Spline */
        /*
          P(t) = 0.5*( -t.(1-t)^3.P0 + (2-5t^2+3t^3)*P1 + t(1+4t-3t^2).P2 + -t^2.(1-t).P3 );
        */
        P->p3.d[0] = 0.5*(-1*t*pow((1-t),3.0)*P0.p3.d[0] + (2 - 5.0*pow(t,2.0) + 3.0*pow(t,3.0))*P1.p3.d[0] + t*(1 + 4.0*t - 3.0*pow(t,2.0))*P2.p3.d[0] + -1*pow(t,2.0)*(1-t)*P3.p3.d[0]);
        P->p3.d[1] = 0.5*(-1*t*pow((1-t),3.0)*P0.p3.d[1] + (2 - 5.0*pow(t,2.0) + 3.0*pow(t,3.0))*P1.p3.d[1] + t*(1 + 4.0*t - 3.0*pow(t,2.0))*P2.p3.d[1] + -1*pow(t,2.0)*(1-t)*P3.p3.d[1]);
        P->p3.d[2] = 0.5*(-1*t*pow((1-t),3.0)*P0.p3.d[2] + (2 - 5.0*pow(t,2.0) + 3.0*pow(t,3.0))*P1.p3.d[2] + t*(1 + 4.0*t - 3.0*pow(t,2.0))*P2.p3.d[2] + -1*pow(t,2.0)*(1-t)*P3.p3.d[2]);

    }
    else if(currentSpline==BSPLINE) {
        
        /* Parametric equation of B-Spline */
        /*
          P(t) = (1.0/6.0)*( (1-t)^3.P0 + (3t^3 - 6t^2 + 4).P1 + (-3t^3 + 3t^2 + 3t +1).P2 + t^3.P3 );
        */
        P->p3.d[0] = (1.0/6.0)*( pow((1-t),3.0)*P0.p3.d[0] + (3.0*pow(t,3.0) - 6.0*pow(t,2.0) + 4.0)*P1.p3.d[0] + (-3.0*pow(t,3.0) + 3.0*pow(t,2.0) + 3.0*t + 1.0)*P2.p3.d[0] + pow(t,3.0)*P3.p3.d[0]);
        P->p3.d[1] = (1.0/6.0)*( pow((1-t),3.0)*P0.p3.d[1] + (3.0*pow(t,3.0) - 6.0*pow(t,2.0) + 4.0)*P1.p3.d[1] + (-3.0*pow(t,3.0) + 3.0*pow(t,2.0) + 3.0*t + 1.0)*P2.p3.d[1] + pow(t,3.0)*P3.p3.d[1]);
        P->p3.d[2] = (1.0/6.0)*( pow((1-t),3.0)*P0.p3.d[2] + (3.0*pow(t,3.0) - 6.0*pow(t,2.0) + 4.0)*P1.p3.d[2] + (-3.0*pow(t,3.0) + 3.0*pow(t,2.0) + 3.0*t + 1.0)*P2.p3.d[2] + pow(t,3.0)*P3.p3.d[2]);
        
    }
	else if(currentSpline==NOSPLINE) { //LERP
		
	}
}
void constructKnot ( void )
{
	double	t	= 0.0;
	int		i	= 0;
	int		mod	= 0;
	double	div	= 1.0;
	double	inc	= 0.0;
	int		m =	mo2->m;
	int		n =	mo2->n;
	double	a =	mo2->a;
	double	b =	mo2->b;
	double	r =	mo2->r;
	double	maxAngle = 0.0;
	
	/* // Equation of Torus	Knot
	///////////////////////////////////
	torusknot[a_,b_,c_][p_,q_][t_] :=
	{(a	+ b*Cos[q*t])*Cos[p*t],
	(a + b*Cos[q*t])*Sin[p*t],
	c*Sin[q*t]}
	//////////////////////////////////
	*/

	// WARNING:
	// date: 01-17-2005
	// for : solving the double	covering problem
	// :( needs	the	prime numbers to make sure the cases are accounted for.	But
	// this	handles	only a few cases. A	prime-number generater would make it generic.
	if(m==n)
		div=(double)m;

	if(m>n)	{
		mod	= m%n;
		if(mod==0) {
			div=(double)n;
		}
		else {
			if(m%2==0 && n%2==0	&& mod%2==0){
				if((m%mod)%2==0)
				{
					if(m%4==0 && n%4==0)
						div=(double)4;
					else
						div=(double)2;
				}
				else 
					div=(double)mod;
			}

			if(m%3==0 && n%3==0	&& mod%3==0){
				if((m%mod)%3==0)
				{
					if(m%6==0 && n%6==0)
						div=(double)6;
					else
						div=(double)3;
				}			
				else
					div=(double)mod;
			}
			
			if(m%5==0 && n%5==0	&& mod%5==0){
				if((n%mod)%5==0)
					div=(double)5;
				else
					div=(double)mod;
			}

			if(m%7==0 && n%7==0	&& mod%7==0){
				if((n%mod)%7==0)
					div=(double)7;
				else
					div=(double)mod;
			}
		}
		
	}
	
	else {
		mod	= n%m;
		if(mod==0) {
			div=(double)m;
		}
		else {
			if(m%2==0 && n%2==0	&& mod%2==0){
				if((m%mod)%2==0)
				{
					if(m%4==0 && n%4==0)
						div=(double)4;
					else
						div=(double)2;
				}
				else
					div=(double)mod;
			}
			if(m%3==0 && n%3==0	&& mod%3==0){
				if((m%mod)%3==0)
				{
					if(m%6==0 && n%6==0)
						div=(double)6;
					else
						div=(double)3;
				}			
				else
					div=(double)mod;
			}
			if(m%5==0 && n%5==0	&& mod%5==0){
				if((m%mod)%5==0)
					div=(double)5;
				else
					div=(double)mod;
			}
			if(m%7==0 && n%7==0	&& mod%7==0){
				if((m%mod)%7==0)
					div=(double)7;
				else
					div=(double)mod;
			}
		}
	}
	//@@

	inc	= Max(0.04,mo2->increment/Max(m,n));
	
	mo2->numPoints = 0;
	if(div>0) {
		maxAngle = 2.0;
		while(t<=maxAngle*M_PI/div) {
			
			mo2->pntList[i].p3.d[0]	= (r + a*cos(n*t))*cos(m*t);
			mo2->pntList[i].p3.d[1]	= (r + a*cos(n*t))*sin(m*t);
			mo2->pntList[i].p3.d[2]	= b*sin( n*t );
			//fprintf(stderr,"pntList[%d] =	%f,	%f,	%f\n",i, mo2->pntList[i].p3.d[0],mo2->pntList[i].p3.d[1],mo2->pntList[i].p3.d[2]);
			i++;
			t =	t+inc;
		}
		//NOTE: original> 
		mo2->numPoints = i-1;

		//mo2->numPoints = 10;
	}
}

void makeTangent ( void	) 
{
	int		i = 0;
	int		limit = 0;
	double	p1[3];
	double	p2[3];				//points on	spline	  
	double	len = 0.0;
	double	v[3];

	if(mo2->flag_curve_closed)
		limit = mo2->numPoints;
	else
		limit = mo2->numPoints-1;


	//////////////// BUILD Tangents	/////////////////////////////////
	for	( i=0; i<(limit); i++ ) {

		p1[0] =	mo2->pntList[i].p3.d[0];
		p1[1] =	mo2->pntList[i].p3.d[1];
		p1[2] =	mo2->pntList[i].p3.d[2];

		if(i==(mo2->numPoints-1)) {
			p2[0] =	mo2->pntList[0].p3.d[0];
			p2[1] =	mo2->pntList[0].p3.d[1];
			p2[2] =	mo2->pntList[0].p3.d[2];
		}
		else {
			p2[0] =	mo2->pntList[i+1].p3.d[0];
			p2[1] =	mo2->pntList[i+1].p3.d[1];
			p2[2] =	mo2->pntList[i+1].p3.d[2];
		}
		//printf("[%d] Point2 = %f, %f ,%f\n",i,p2[0],p2[1],p2[2]);

		v[0] = p2[0]-p1[0];
		v[1] = p2[1]-p1[1];
		v[2] = p2[2]-p1[2];
	
		len	= length3D(v);
	
		v[0] = v[0]/len;
		v[1] = v[1]/len;
		v[2] = v[2]/len;

		mo2->TangList[i].p3.d[0] = v[0];
		mo2->TangList[i].p3.d[1] = v[1];
		mo2->TangList[i].p3.d[2] = v[2];
		//printf("[%d] Tang = %f, %f ,%f\n",i,v[0],v[1],v[2]);
	}
}

void makeTangentDerivatives	( void ) 
{
	int		i = 0;
	int		limit = 0;
	double	t = 0;
	double	len	 = 0.0;
	
	double T0[3];
	double T1[3];
	double TT[3];

	if(mo2->flag_curve_closed)
		limit = mo2->numPoints;
	else
		limit = mo2->numPoints-2;

	for(i=0; i<limit; i++) {
		t=0;
		T0[0] =	mo2->TangList[i].p3.d[0];
		T0[1] =	mo2->TangList[i].p3.d[1];
		T0[2] =	mo2->TangList[i].p3.d[2];
		
		if(i==(mo2->numPoints-1)) {
			T1[0] =	mo2->TangList[0].p3.d[0];
			T1[1] =	mo2->TangList[0].p3.d[1];
			T1[2] =	mo2->TangList[0].p3.d[2];
		}
		else {
			T1[0] =	mo2->TangList[i+1].p3.d[0];
			T1[1] =	mo2->TangList[i+1].p3.d[1];
			T1[2] =	mo2->TangList[i+1].p3.d[2];
		}
		minus3D(T1,T0,TT);

		len	= length3D(TT);
		
		TT[0] =	TT[0]/len;
		TT[1] =	TT[1]/len;
		TT[2] =	TT[2]/len;

		mo2->dTangList[i].p3.d[0] =	TT[0];
		mo2->dTangList[i].p3.d[1] =	TT[1];
		mo2->dTangList[i].p3.d[2] =	TT[2];
		//printf("[%d] dTang = %f, %f ,%f\n",i,TT[0],TT[1],TT[2]);
	}
}

void computeFrenetSerretFrame ( void ) 
{
	int		i = 0;						
	int		limit = mo2->numPoints;			// total points to compute for
	double	normB;							// lenght of various vectors
	double	b[3];							// dot and cross product results
	double	n[3];							// vector for cross	product	of Binormal	and	Tangent
	double	t[3];							// vector for Tangent
	double	tt[3];							// vector for first	derivative of Tangent

	//for asigning quaternions
	double		mat[16];					// 4x4 matrix
	double		dotPrevCurrBinormal = 0.0;	// dot product
	double		qdotProd_PQ = 0.0;			// quaternion dot product
	double		prevb[3];					// previous binormal
	quaternion	*q, *p, *r;					// quaternion
	
	//init quaternions
	p =	(quaternion*) my_malloc(sizeof(quaternion));
	q =	(quaternion*) my_malloc(sizeof(quaternion));
	r =	(quaternion*) my_malloc(sizeof(quaternion));
	
	mo2->markFrameCounter =	0;
	mo2->markQuatCurveCounter = 0;

	if(limit>2) {

		for(i=0; i<limit; i++) {
			//printf("[%d]\n",i);
			//### Compute Frenet Frame ###
			t[0] = mo2->TangList[i].p3.d[0];
			t[1] = mo2->TangList[i].p3.d[1];
			t[2] = mo2->TangList[i].p3.d[2];
			//printf("norm(t) = %f\n",length3D(t));

			tt[0] =	mo2->dTangList[i].p3.d[0];
			tt[1] =	mo2->dTangList[i].p3.d[1];
			tt[2] =	mo2->dTangList[i].p3.d[2];
		
			//obtain cross product of tangent and derivative of	tangent
			cross3D(t, tt, b);

			//obtain length	of vector cross_vt
			normB = length3D(b);
			
			//normalize	vector cross_vt
			b[0] =	b[0]/normB;
			b[1] =	b[1]/normB;
			b[2] =	b[2]/normB;

		   //save cross_vt into	vector list
			mo2->fsRBasis[i].p3.d[0] = b[0];
			mo2->fsRBasis[i].p3.d[1] = b[1];
			mo2->fsRBasis[i].p3.d[2] = b[2];
			//printf("norm(b) = %f\n",length3D(b));

			//obtain cross product of Binormal and Tangent
			cross3D(b, t, n);
			//printf("norm(n) = %f\n",length3D(n));
			//save cross_BV	into vector	list
			mo2->fsSBasis[i].p3.d[0] = n[0];
			mo2->fsSBasis[i].p3.d[1] = n[1];
			mo2->fsSBasis[i].p3.d[2] = n[2];

			//### Assign Quaternions ###
			//obtain 4x4 matrix
			mat[0] = n[0];
			mat[1] = n[1];
			mat[2] = n[2];

			mat[4] = b[0];
			mat[5] = b[1];
			mat[6] = b[2];

			mat[8] = t[0];
			mat[9] = t[1];
			mat[10]= t[2];		

			mat[3]	= mat[7] = mat[11] = mat[12] = mat[13] = mat[14] = 0.0;
			mat[15]	= 1.0;
			/*if(i==0) {
				printf("t = %f, %f, %f\n",t[0],t[1],t[2]);
				printf("n = %f, %f, %f\n",n[0],n[1],n[2]);
				printf("b = %f, %f, %f\n",b[0],b[1],b[2]);

				printf("ROTATION MATRIX: \n");
				printf("%.4f\t%.4f\t%.4f\t%.4f\n", mat[0], mat[4], mat[8],  mat[12]);
				printf("%.4f\t%.4f\t%.4f\t%.4f\n", mat[1], mat[5], mat[9],  mat[13]);
				printf("%.4f\t%.4f\t%.4f\t%.4f\n", mat[2], mat[6], mat[10], mat[14]);
				printf("%.4f\t%.4f\t%.4f\t%.4f\n", mat[3], mat[7], mat[11], mat[15]);
				printf("\n");
			}*/
			ExtractQuaternionFromMat( mat, q );
			quatNormalize( q );	
			
			if(i>0) {
				dotPrevCurrBinormal = dot3D(prevb, b);
				if(dotPrevCurrBinormal<=0.6) {
					mo2->markFrame[mo2->markFrameCounter] = i-1;
					mo2->markFrameCounter++;
					mo2->markQuatCurve[mo2->markQuatCurveCounter] = i-1;
					mo2->markQuatCurveCounter++;
				}
				qdotProd_PQ = quatQuatDotProduct( p, q );
				if(qdotProd_PQ < -0.9) {
					r->r = -q->r;
					r->i = -q->i;
					r->j = -q->j;
					r->k = -q->k;
					quatCopy(r, q);				
				}
			}
			//save quaternions
			mo2->fsQuatList[i].r = q->r;
			mo2->fsQuatList[i].i = q->i;
			mo2->fsQuatList[i].j = q->j;
			mo2->fsQuatList[i].k = q->k;

			//copy current-binormal into previous-binormal
			prevb[0] = b[0];
			prevb[1] = b[1];
			prevb[2] = b[2];
			//copy current quaternion into previous one
			quatCopy( q, p );

		}//$FOR(i..)
		my_free(q);
	}//$IF(limit>2)
}

void computeParallelTransportFrame ( void ) 
{
	int		i=0;			// index into points array
	double	t[3];			// arbitrary vector
	double	v[3];			// vector for Tangent
	double	s[3];			// vector for third	orthonormal	component
	double	v0[3];			// vector for initial normal vector

	double	len;			// vector lenght
	double	theta	=	0.0;// PT initial frame	angle
	double	t1[3];			// vector for Tangent
	double	t2[3];			// vector for Tangent
	double	cross_T1T2[3];			// vector for tangent-tangent cross	product
	double	angle = mo2->startTheta;
	quaternion *p,*q,*u, *prev;
	p =	(quaternion*) malloc(sizeof(quaternion));
	q =	(quaternion*) malloc(sizeof(quaternion));
	u =	(quaternion*) malloc(sizeof(quaternion));
	prev = (quaternion*) malloc(sizeof(quaternion));

	int		limit	= 0;	// local variable for number of	points for frame calculation
	limit = mo2->numPoints-1;

	//quaternions
	//double	dot_vt	= 0.0;
	//double	phi		= 0.0;

	t[0] = 0.0;
	t[1] = 0.0;
	t[2] = 1.0;

	//@ Make first frame same as FRENET
	//get first axis perp. to first tangent
	v0[0] = mo2->fsRBasis[0].p3.d[0];
	v0[1] = mo2->fsRBasis[0].p3.d[1];
	v0[2] = mo2->fsRBasis[0].p3.d[2];

	//get first tangent
	v[0] = mo2->TangList[0].p3.d[0];
	v[1] = mo2->TangList[0].p3.d[1];
	v[2] = mo2->TangList[0].p3.d[2];

	//rotate v0 by start-angle
	rotate3D_3(v0, v, angle);
	len=length3D(v0);
	v0[0] /= len;
	v0[1] /= len;
	v0[2] /= len;

	//copy v0 into basisRList
	mo2->ptRBasis[0].p3.d[0] = v0[0];
	mo2->ptRBasis[0].p3.d[1] = v0[1];
	mo2->ptRBasis[0].p3.d[2] = v0[2];

	//compute third component S
	cross3D(v0,v,s);	
	mo2->ptSBasis[0].p3.d[0] = s[0];
	mo2->ptSBasis[0].p3.d[1] = s[1];
	mo2->ptSBasis[0].p3.d[2] = s[2];

	//compute quaternion affected by rotation by angle
	prev->r = cos(angle/2.0);
	prev->i = v[0]*sin(angle/2.0);
	prev->j = v[1]*sin(angle/2.0);
	prev->k = v[2]*sin(angle/2.0);

	quatQuatProduct( prev, &(mo2->fsQuatList[0]), u);
	quatCopy( u, &(mo2->ptQuatList[0]) );

	//@ Calculate for all points
	for(i=0;i<(limit);i++) {
		
		t1[0] =	mo2->TangList[i].p3.d[0];
		t1[1] =	mo2->TangList[i].p3.d[1];
		t1[2] =	mo2->TangList[i].p3.d[2];

		t2[0] =	mo2->TangList[i+1].p3.d[0];
		t2[1] =	mo2->TangList[i+1].p3.d[1];
		t2[2] =	mo2->TangList[i+1].p3.d[2];

		cross3D(t1,t2, cross_T1T2);
		len	= length3D(cross_T1T2);

		//get current quaternion
		p->r = mo2->ptQuatList[i].r;
		p->i = mo2->ptQuatList[i].i;
		p->j = mo2->ptQuatList[i].j;
		p->k = mo2->ptQuatList[i].k;

		if(len == 0) {
			printf("[%d] len = %f\n",i,len);
			//copy current basisR into next	basisRList
			mo2->ptRBasis[i+1].p3.d[0] = mo2->ptRBasis[i].p3.d[0];
			mo2->ptRBasis[i+1].p3.d[1] = mo2->ptRBasis[i].p3.d[1];
			mo2->ptRBasis[i+1].p3.d[2] = mo2->ptRBasis[i].p3.d[2];
			
			//copy basisRList into v0
			v0[0] =	mo2->ptRBasis[i+1].p3.d[0];
			v0[1] =	mo2->ptRBasis[i+1].p3.d[1];
			v0[2] =	mo2->ptRBasis[i+1].p3.d[2];

			//assign next quaternion
			quatCopy (p, &(mo2->ptQuatList[i+1]) );
			//printf("in here kya? %d\n",i);
		}
		else {
			cross_T1T2[0] /= len;
			cross_T1T2[1] /= len;
			cross_T1T2[2] /= len;
			theta =	acos(dot3D(t1,t2));
			rotate3D_3(v0, cross_T1T2, theta);
			
			//copy v0 into basisRList
			mo2->ptRBasis[i+1].p3.d[0] = v0[0];
			mo2->ptRBasis[i+1].p3.d[1] = v0[1];
			mo2->ptRBasis[i+1].p3.d[2] = v0[2];

			//compute next quaternion
			q->r = cos(theta/2.0);
			q->i = cross_T1T2[0]*sin(theta/2.0);
			q->j = cross_T1T2[1]*sin(theta/2.0);
			q->k = cross_T1T2[2]*sin(theta/2.0);
			quatQuatProduct	(q,	p, u);
			quatNormalize(u);
	
			//asign next quaternion
			mo2->ptQuatList[i+1].r = u->r;
			mo2->ptQuatList[i+1].i = u->i;
			mo2->ptQuatList[i+1].j = u->j;
			mo2->ptQuatList[i+1].k = u->k;


		}
		
		cross3D(v0,t2,s);
		len	= length3D(s);
		s[0] /=	len;
		s[1] /=	len;
		s[2] /=	len;

		// copy	s into basisSList
		mo2->ptSBasis[i+1].p3.d[0] = s[0];
		mo2->ptSBasis[i+1].p3.d[1] = s[1];
		mo2->ptSBasis[i+1].p3.d[2] = s[2];
	}
	//int		i		= 0;				// index into points array
	//double	theta	= 0.0;				// PT initial frame	angle
	//int		limit	= 0;				// number of points for calculation
	//double	t[3];						// arbitrary vector
	//double	v[3];						// vector for Tangent
	//double	s[3];						// vector for third	orthonormal	component
	//double	v0[3];						// vector for initial normal vector

	//double	len;						// vector lenght
	//double	t1[3];						// vector for Tangent
	//double	t2[3];						// vector for Tangent
	//double	cross_T1T2[3];				// vector for tangent-tangent cross	product
	//double	cross_R1R2[3];				// cross product of normal vectors of triad
	//double	angle	= mo2->startTheta;	// PT-start-angle for first frame
	//quaternion *p,*q,*u, *prev;			// quaternion variables

	////@ Initializations 
	//p =	(quaternion*) malloc(sizeof(quaternion));
	//q =	(quaternion*) malloc(sizeof(quaternion));
	//u =	(quaternion*) malloc(sizeof(quaternion));
	//prev = (quaternion*) malloc(sizeof(quaternion));

	//limit = mo2->numPoints;

	//t[0] = 0.0;
	//t[1] = 0.0;
	//t[2] = 1.0;

	////@ Make first frame same as FRENET /////////////////////////////
	////get first axis perp. to first tangent
	//v0[0] = mo2->fsRBasis[0].p3.d[0];
	//v0[1] = mo2->fsRBasis[0].p3.d[1];
	//v0[2] = mo2->fsRBasis[0].p3.d[2];

	////get first tangent
	//v[0] = mo2->TangList[0].p3.d[0];
	//v[1] = mo2->TangList[0].p3.d[1];
	//v[2] = mo2->TangList[0].p3.d[2];

	////rotate v0 by start-angle
	//rotate3D_3(v0, v, angle);
	//len=length3D(v0);
	//v0[0] /= len;
	//v0[1] /= len;
	//v0[2] /= len;

	////copy v0 into basisRList
	//mo2->ptRBasis[0].p3.d[0] = v0[0];
	//mo2->ptRBasis[0].p3.d[1] = v0[1];
	//mo2->ptRBasis[0].p3.d[2] = v0[2];

	////compute third component S
	//cross3D(v0,v,s);	
	//mo2->ptSBasis[0].p3.d[0] = s[0];
	//mo2->ptSBasis[0].p3.d[1] = s[1];
	//mo2->ptSBasis[0].p3.d[2] = s[2];

	////compute quaternion affected by rotation by angle
	//prev->r = cos(angle/2.0);
	//prev->i = v[0]*sin(angle/2.0);
	//prev->j = v[1]*sin(angle/2.0);
	//prev->k = v[2]*sin(angle/2.0);

	//quatQuatProduct( prev, &(mo2->fsQuatList[0]), u);
	//quatCopy( u, &(mo2->ptQuatList[0]) );

	////@ Calculate for all points /////////////////////////////
	//for(i=0;i<(limit);i++) {
	//	
	//	t1[0] =	mo2->TangList[i].p3.d[0];
	//	t1[1] =	mo2->TangList[i].p3.d[1];
	//	t1[2] =	mo2->TangList[i].p3.d[2];

	//	t2[0] =	mo2->TangList[i+1].p3.d[0];
	//	t2[1] =	mo2->TangList[i+1].p3.d[1];
	//	t2[2] =	mo2->TangList[i+1].p3.d[2];

	//	cross3D(t1,t2, cross_T1T2);
	//	len	= length3D(cross_T1T2);

	//	//get current quaternion
	//	p->r = mo2->ptQuatList[i].r;
	//	p->i = mo2->ptQuatList[i].i;
	//	p->j = mo2->ptQuatList[i].j;
	//	p->k = mo2->ptQuatList[i].k;

	//	if(len == 0) {
	//		//printf("[%d] len = %f\n",i,len);
	//		//copy current basisR into next	basisRList
	//		mo2->ptRBasis[i+1].p3.d[0] = mo2->ptRBasis[i].p3.d[0];
	//		mo2->ptRBasis[i+1].p3.d[1] = mo2->ptRBasis[i].p3.d[1];
	//		mo2->ptRBasis[i+1].p3.d[2] = mo2->ptRBasis[i].p3.d[2];
	//		
	//		//copy basisRList into v0
	//		v0[0] =	mo2->ptRBasis[i+1].p3.d[0];
	//		v0[1] =	mo2->ptRBasis[i+1].p3.d[1];
	//		v0[2] =	mo2->ptRBasis[i+1].p3.d[2];

	//		//assign next quaternion
	//		quatCopy (p, &(mo2->ptQuatList[i+1]) );
	//	}
	//	else {
	//		cross_T1T2[0] /= len;
	//		cross_T1T2[1] /= len;
	//		cross_T1T2[2] /= len;
	//		theta =	acos(dot3D(t1,t2));
	//		rotate3D_3(v0, cross_T1T2, theta);
	//		
	//		//copy v0 into basisRList
	//		mo2->ptRBasis[i+1].p3.d[0] = v0[0];
	//		mo2->ptRBasis[i+1].p3.d[1] = v0[1];
	//		mo2->ptRBasis[i+1].p3.d[2] = v0[2];

	//		//compute next quaternion
	//		q->r = cos(theta/2.0);
	//		q->i = cross_T1T2[0]*sin(theta/2.0);
	//		q->j = cross_T1T2[1]*sin(theta/2.0);
	//		q->k = cross_T1T2[2]*sin(theta/2.0);
	//		quatQuatProduct	(q,	p, u);
	//		quatNormalize(u);
	//
	//		//asign next quaternion
	//		mo2->ptQuatList[i+1].r = u->r;
	//		mo2->ptQuatList[i+1].i = u->i;
	//		mo2->ptQuatList[i+1].j = u->j;
	//		mo2->ptQuatList[i+1].k = u->k;


	//	}

	//	//@ compute quaternions here /////////////////////////////
	//	if(FALSE) {
	//	cross3D( mo2->ptRBasis[i].p3.d, mo2->ptRBasis[i+1].p3.d, cross_R1R2 );
	//	len = length3D( cross_R1R2 );

	//	if(len < 0.000000001) {
	//		//asign next quaternion
	//		quatCopy (p, &(mo2->ptQuatList[i+1]) );
	//	}
	//	else {
	//		cross_R1R2[0] /= len;
	//		cross_R1R2[1] /= len;
	//		cross_R1R2[2] /= len;
	//		theta =	acos( dot3D( mo2->ptRBasis[i].p3.d, mo2->ptRBasis[i+1].p3.d ) );
	//		
	//		//make new quaternion
	//		q->r = cos(theta/2.0);
	//		q->i = cross_R1R2[0]*sin(theta/2.0);
	//		q->j = cross_R1R2[1]*sin(theta/2.0);
	//		q->k = cross_R1R2[2]*sin(theta/2.0);
	//		quatQuatProduct	(q,	p, u);
	//		quatNormalize(u);
	//
	//		//asign next quaternion
	//		mo2->ptQuatList[i+1].r = u->r;
	//		mo2->ptQuatList[i+1].i = u->i;
	//		mo2->ptQuatList[i+1].j = u->j;
	//		mo2->ptQuatList[i+1].k = u->k;
	//	}
	//	}
	//	
	//	//@ compute third component of triad /////////////////////
	//	cross3D(v0,t2,s);
	//	len	= length3D(s);
	//	s[0] /=	len;
	//	s[1] /=	len;
	//	s[2] /=	len;

	//	// copy	s into basisSList
	//	mo2->ptSBasis[i+1].p3.d[0] = s[0];
	//	mo2->ptSBasis[i+1].p3.d[1] = s[1];
	//	mo2->ptSBasis[i+1].p3.d[2] = s[2];
	//}

	//cross3D(mo2->ptRBasis[limit-1].p3.d, mo2->TangList[limit-1].p3.d, s);
	//len	= length3D(s);
	////s[0] /=	len;
	////s[1] /=	len;
	////s[2] /=	len;
	//// copy	s into basisSList
	//mo2->ptSBasis[limit-1].p3.d[0] = s[0];
	//mo2->ptSBasis[limit-1].p3.d[1] = s[1];
	//mo2->ptSBasis[limit-1].p3.d[2] = s[2];

	//glPushMatrix();
	//glTranslatef(mo2->pntList[limit-1].p3.d[0],mo2->pntList[limit-1].p3.d[1],mo2->pntList[limit-1].p3.d[2]);
	//glColor3f(0,0,0);
	//glutSolidSphere(0.025,16,16);
	//glBegin(GL_LINES);
	//glVertex3f(0,0,0);
	//glVertex3f(s[0],s[1],s[2]);
	//glEnd();
	//glPopMatrix();
	
}
//# RENDERINGS
void drawKnot ( void ) 
{
	int		i = 0;
	int		limit = mo2->numPoints;

    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);
	//glPointSize(size);
	//glBegin(GL_POINTS);
	//for(i=0; i<mo2->numPoints; i++) {
	//	glVertex3f( mo2->pntList[i].p3.d[0], mo2->pntList[i].p3.d[1], mo2->pntList[i].p3.d[2] );
	//}
	//glEnd();
	for(i=0;i<limit;i++) {
		if(i==0) 
			glColor3f(0.9f,0.7f,0.0f);
		else
			glColor3f(0.5f,0.5f,0.5f);

		glPushMatrix();
			glTranslatef( mo2->pntList[i].p3.d[0], mo2->pntList[i].p3.d[1], mo2->pntList[i].p3.d[2] );
			glutSolidSphere(0.02,16,16);
		glPopMatrix();
	}
	glPopAttrib();
}

void drawKnottedCurve ( void ) 
{
	int		i = 0;
	float	size = 1.25f;
	int		limit = mo2->numPoints;

    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glDisable(GL_LIGHTING);
	glColor3f(0.0f,0.0f,0.0f);
	glLineWidth(size);
	glBegin(GL_LINE_STRIP);
	for(i=0; i<=limit; i++) {
		if(i<limit)
			glVertex3f( mo2->pntList[i].p3.d[0], mo2->pntList[i].p3.d[1], mo2->pntList[i].p3.d[2] );
		else if(!mo2->showGap)
			glVertex3f( mo2->pntList[0].p3.d[0], mo2->pntList[0].p3.d[1], mo2->pntList[0].p3.d[2] );
	}
	glEnd();
	glPopAttrib();
}
void drawPoint ( double *point, float size, int name, GLenum mode)
{
	glPointSize(size);
	if(mode == GL_SELECT){
		glLoadName(name);
	}
	glBegin(GL_POINTS);
		glVertex3f( point[0], point[1], point[2] );
	glEnd();
}
void drawPoints ( GLenum mode )
{
    int i;
	float size=10.0;
    
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glDisable(GL_LIGHTING);
    for(i=0; i<mo2->numCtrlPoints; i++){
		if(i == mo2->selected_point){
			glColor3f(1.0f,0.0f,0.0f);
			size = 25;
		}
		else {
			glColor3f(0.0f,0.0f,0.0f);
		}
		drawPoint( (mo2->ctrlPntList[i].p3.d), size, i, mode);
		size = 10.0;
    }
    glPopAttrib();
}
void drawCurve ( void )
{
	int i=0;
	int	limit = -1;
	float size = 1.25f;
	if(mo2->objectID == OBJCURVE && mo2->whichCurve==OBJSPLINE)
		limit = mo2->numPoints;

	glPushAttrib( GL_ALL_ATTRIB_BITS );
	glDisable( GL_LIGHTING );
	glLineWidth(size);
	glColor3f(0.0f,0.0f,0.0f);
	glBegin( GL_LINE_STRIP );
	for(i=0;i<limit;i++) {
		glVertex3f( mo2->pntList[i].p3.d[0], mo2->pntList[i].p3.d[1], mo2->pntList[i].p3.d[2] );
	}
	glEnd();
	glEnable(GL_LIGHTING);
	glColor3f(0.0f,0.6f,0.6f);
	
	for(i=0;i<limit;i++) {
		glPushMatrix();
			glTranslatef( mo2->pntList[i].p3.d[0], mo2->pntList[i].p3.d[1], mo2->pntList[i].p3.d[2] );
			glutSolidSphere(0.015,8,8);
		glPopMatrix();
	}
	glPopAttrib();

}
void drawTangentsDTangents ( void )
{
	int		i = 0;
	int		limit = 0;
	double	scale = 0.5;
	float	size = 1.5f;

	if(mo2->flag_curve_closed)
		limit = mo2->numPoints;
	else
		limit = mo2->numPoints-2;

	glPushAttrib( GL_ALL_ATTRIB_BITS );
	glDisable( GL_LIGHTING );
	glLineWidth( size );
	glColor3f(0.0f,0.65f,0.85f);
	for(i=0;i<limit;i++) {
		glPushMatrix();
			glTranslatef( mo2->pntList[i].p3.d[0], mo2->pntList[i].p3.d[1], mo2->pntList[i].p3.d[2] );
			glScalef(scale,scale,scale);
			glBegin(GL_LINES);
				glVertex3f(0.0f,0.0f,0.0f);
				glVertex3f(mo2->TangList[i].p3.d[0],mo2->TangList[i].p3.d[1],mo2->TangList[i].p3.d[2]);
			glEnd();
		glPopMatrix();
	}
	
	glColor3f(0.65f,0.0f,0.85f);
	limit = mo2->numPoints;
	scale = 0.33;
	for(i=0;i<limit;i++) {
		glPushMatrix();
			glTranslatef( mo2->pntList[i].p3.d[0], mo2->pntList[i].p3.d[1], mo2->pntList[i].p3.d[2] );
			glScalef(scale,scale,scale);
			glBegin(GL_LINES);
				glVertex3f(0.0f,0.0f,0.0f);
				glVertex3f(mo2->dTangList[i].p3.d[0],mo2->dTangList[i].p3.d[1],mo2->dTangList[i].p3.d[2]);
			glEnd();
		glPopMatrix();
	}
	glPopAttrib();
}
void drawFrames ( void )
{
	int		i = 0;
	int		limit = 0;
	double	scale = 0.25;
	float	size = 1.5f;

	if(mo2->flag_curve_closed)
		limit = mo2->numPoints;
	else
		limit = mo2->numPoints-2;

	glPushAttrib( GL_ALL_ATTRIB_BITS );
	glDisable( GL_LIGHTING );
	glLineWidth( size );

	if(mo2->whichFrame == FRENETSERRET) {

		for(i=0;i<limit;i++) {
			glPushMatrix();
				glTranslatef( mo2->pntList[i].p3.d[0], mo2->pntList[i].p3.d[1], mo2->pntList[i].p3.d[2] );
				glScalef(scale,scale,scale);
				glColor3f(1.0f,0.0f,0.0f);
				glBegin(GL_LINES);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(mo2->TangList[i].p3.d[0],mo2->TangList[i].p3.d[1],mo2->TangList[i].p3.d[2]);
				glEnd();
				glColor3f(0.0f,1.0f,0.0f);
				glBegin(GL_LINES);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(mo2->fsRBasis[i].p3.d[0],mo2->fsRBasis[i].p3.d[1],mo2->fsRBasis[i].p3.d[2]);
				glEnd();
				glColor3f(0.0f,0.0f,1.0f);
				glBegin(GL_LINES);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(mo2->fsSBasis[i].p3.d[0],mo2->fsSBasis[i].p3.d[1],mo2->fsSBasis[i].p3.d[2]);
				glEnd();
			glPopMatrix();
		}	
	}//# IF(whichFrame..)
	else if(mo2->whichFrame == PARALLELTRANSPORT) {
		for(i=0;i<limit;i++) {
			glPushMatrix();
				glTranslatef( mo2->pntList[i].p3.d[0], mo2->pntList[i].p3.d[1], mo2->pntList[i].p3.d[2] );
				glScalef(scale,scale,scale);
				glColor3f(1.0f,0.0f,0.0f);
				glBegin(GL_LINES);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(mo2->TangList[i].p3.d[0],mo2->TangList[i].p3.d[1],mo2->TangList[i].p3.d[2]);
				glEnd();
				glColor3f(0.0f,1.0f,0.0f);
				glBegin(GL_LINES);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(mo2->ptRBasis[i].p3.d[0],mo2->ptRBasis[i].p3.d[1],mo2->ptRBasis[i].p3.d[2]);
				glEnd();
				glColor3f(0.0f,0.0f,1.0f);
				glBegin(GL_LINES);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(mo2->ptSBasis[i].p3.d[0],mo2->ptSBasis[i].p3.d[1],mo2->ptSBasis[i].p3.d[2]);
				glEnd();
			glPopMatrix();
		}	
	}
}
void drawQuaternionCurve ( void )
{
	int		i = 0;
	int		limit = 0;
	double	qvec[3];
	float	size = 2.25f;

	if(mo2->flag_curve_closed)
		limit = mo2->numPoints;
	else
		limit = mo2->numPoints-2;

	//draw unit sphere
	if(mo2->qshowSphere) {
		glDisable(GL_LIGHTING);
		glColor3f(0.75f,0.75f,0.75f);
		glutWireSphere(1.0,16,16);
	}

	//@ Draw Quaternion points and curve
    glPushAttrib(GL_ALL_ATTRIB_BITS);
	glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);
	glLineWidth(size);
	//points
	if(mo2->whichFrame == FRENETSERRET) {
		for(i=0; i<limit; i++) {
		
			if(i==0) 
				glColor3f(0.9f,0.7f,0.0f);
			else if(i%5==0 && mo2->showLabels)
					glColor3f(0.0f,0.5f,0.5f);
			else
				glColor3f(0.2f,0.7f,0.7f);
			getQuatComp(mo2->qwhichQuatComponent, &(mo2->fsQuatList[i]), qvec);

			glPushMatrix();
				glTranslatef( qvec[0], qvec[1], qvec[2] );
				glutSolidSphere(0.02,16,16);
				if(mo2->showLabels && i%5==0) {
					glPushAttrib(GL_LIGHTING_BIT);
					glDisable(GL_LIGHTING);
					glColor3f(0.7f,1.0f,1.0f);
					sprintf(obj_qstr,"%d",i);
					glRasterPos2f(0.03,0.03);
					mo2->qfont = GLUT_BITMAP_HELVETICA_10;
					stext(obj_qstr);
					glPopAttrib();				
				}
			glPopMatrix();
		}

		//curve
		glColor3f(0.3f,0.8f,0.8f);
		glDisable(GL_LIGHTING);
		glBegin(GL_LINE_STRIP);
		for(i=0; i<limit; i++) {
			getQuatComp(mo2->qwhichQuatComponent, &(mo2->fsQuatList[i]), qvec);
			glVertex3f( qvec[0], qvec[1], qvec[2] );
		}
		glEnd();
	}

	if(mo2->whichFrame == PARALLELTRANSPORT) {
		for(i=0; i<limit; i++) {
		
			if(i==0) 
				glColor3f(0.9f,0.7f,0.0f);
			else if(i%5==0 && mo2->showLabels)
					glColor3f(0.0f,0.5f,0.5f);
			else if(i==limit-1)
				glColor3f(0.0f,0.9f,0.0f);
			else
				glColor3f(0.2f,0.7f,0.7f);
			getQuatComp(mo2->qwhichQuatComponent, &(mo2->ptQuatList[i]), qvec);

			glPushMatrix();
				glTranslatef( qvec[0], qvec[1], qvec[2] );
				glutSolidSphere(0.02,16,16);
				if(mo2->showLabels && i%5==0) {
					glPushAttrib(GL_LIGHTING_BIT);
					glDisable(GL_LIGHTING);
					glColor3f(0.7f,1.0f,1.0f);
					sprintf(obj_qstr,"%d",i);
					glRasterPos2f(0.03,0.03);
					mo2->qfont = GLUT_BITMAP_HELVETICA_10;
					stext(obj_qstr);
					glPopAttrib();				
				}
			glPopMatrix();
		}

		//curve
		glColor3f(0.3f,0.8f,0.8f);
		glDisable(GL_LIGHTING);
		glBegin(GL_LINE_STRIP);
		for(i=0; i<limit; i++) {
			getQuatComp(mo2->qwhichQuatComponent, &(mo2->ptQuatList[i]), qvec);
			glVertex3f( qvec[0], qvec[1], qvec[2] );
		}
		glEnd();
	}
	glPopAttrib();

	//@ Draw Reflected Quaternion curve
	if(mo2->qshowReflectedPoints) {
	    glPushAttrib(GL_ALL_ATTRIB_BITS);
		glEnable(GL_LIGHTING);
		glEnable(GL_COLOR_MATERIAL);
		glLineWidth(size);

		copyQuatList();

		//points
		for(i=0; i<limit; i++) {
		
			if(i==0) 
				glColor3f(0.9f,0.7f,0.0f);
			else if(i%5==0 && mo2->showLabels)
				glColor3f(0.5f,0.0f,0.5f);
			else
				glColor3f(0.7f,0.2f,0.7f);
			getQuatComp(mo2->qwhichQuatComponent, &(mo2->refquatList[i]), qvec);

			glPushMatrix();
				glTranslatef( qvec[0], qvec[1], qvec[2] );
				glutSolidSphere(0.02,16,16);
				if(mo2->showLabels && i%5==0) {
					glPushAttrib(GL_LIGHTING_BIT);
					glDisable(GL_LIGHTING);
					glColor3f(1.0f,0.7f,1.0f);
					sprintf(obj_qstr,"%d",i);
					glRasterPos2f(0.025,0.025);
					mo2->qfont = GLUT_BITMAP_HELVETICA_10;
					stext(obj_qstr);
					glPopAttrib();				
				}
			glPopMatrix();
		}

		//curve
		glColor3f(0.8f,0.3f,0.8f);
		glDisable(GL_LIGHTING);
		glBegin(GL_LINE_STRIP);
		for(i=0; i<limit; i++) {
			getQuatComp(mo2->qwhichQuatComponent, &(mo2->refquatList[i]), qvec);
			glVertex3f( qvec[0], qvec[1], qvec[2] );
		}
		glEnd();
		glPopAttrib();
	}

}
void drawQuaternionRings ( void )
{
	int		i			= 0;
	float	size		= 3.0f;
	double	qvec[3];
	int		limit		= 0;
	double	tangent[3];
	double	crossZT[3];
	double	norm_crossZT= 0.0;
	double	z[3]		= {0.0, 0.0, 1.0};
	double	thetaZT		= 0.0;
	double	theta		= 0.0;
	double	delta		= 0.25;
	
	quaternion	*q, *f, *b;					// quaternion
	
	//init quaternions
	b =	(quaternion*) my_malloc(sizeof(quaternion));
	f =	(quaternion*) my_malloc(sizeof(quaternion));
	q =	(quaternion*) my_malloc(sizeof(quaternion));

	if(mo2->flag_curve_closed)
		limit = mo2->numPoints;
	else
		limit = mo2->numPoints-2;

	glPushMatrix();
	glRotatef(0,0,0,1);
	for(i=0; i<limit; i++) {

		tangent[0] =	mo2->TangList[i].p3.d[0];
		tangent[1] =	mo2->TangList[i].p3.d[1];
		tangent[2] =	mo2->TangList[i].p3.d[2];

		//compute (z x tangent)
		cross3D( z, tangent, crossZT );
		norm_crossZT = length3D( crossZT );
		crossZT[0] /= norm_crossZT;
		crossZT[1] /= norm_crossZT;
		crossZT[2] /= norm_crossZT;

		//printf("[%d] norm(crossZT) = %f\n", i, length3D(crossZT) );
		//compute arccos(z . tangent)
		thetaZT = acos( dot3D( z, tangent ) );

		//compute b(vhat)
		b->r = cos( thetaZT/2.0 );
		b->i = crossZT[0]*sin( thetaZT/2.0 );
		b->j = crossZT[1]*sin( thetaZT/2.0 );
		b->k = crossZT[2]*sin( thetaZT/2.0 );
		//printf("norm(b) = %f\n", qNorm(b) );
		
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glDisable(GL_LIGHTING);
		glPointSize(size);
		
		theta = 0.0;

		if(i==mo2->trackingRing) {
			glColor3f(0.85f,0.0f,0.0f);
			glLineWidth(4.0);
			glBegin(GL_LINE_STRIP);
		}
		else {
			if(i==0) {
				glColor3f(1.0f,1.0f,0.0f);
			}
			else if(i==limit-1) {
				glColor3f(0.0f,1.0f,0.0f);
			}
			else {
				glColor3f(0.2f,0.2f,0.2f);
			}

		}
		if(mo2->numOfRings==0) {
			if( (i==0 || i==limit-1 || i==mo2->trackingRing) ) {

				glBegin( GL_LINE_STRIP );
				while( theta <=4.0*M_PI+delta ) {

					//compute q(theta, vhat)
					q->r = cos( theta/2.0 );
					q->i = tangent[0]*sin( theta/2.0 );
					q->j = tangent[1]*sin( theta/2.0 );
					q->k = tangent[2]*sin( theta/2.0 );
					//printf("[t=%f] norm(q) = %f\n", theta, qNorm(q) );
					
					quatQuatProduct( q, b, f );
					//f->r = q->r*b->r - q->i*b->i - q->j*b->j - q->k*b->k;
					//f->i = q->i*b->r + q->r*b->i + q->j*b->k - q->k*b->j;
					//f->j = q->j*b->r + q->r*b->j + q->k*b->i - q->i*b->k;
					//f->k = q->k*b->r + q->r*b->k + q->i*b->j - q->j*b->i;

					getQuatComp( mo2->qwhichQuatComponent, f, qvec );
					
					glVertex3f(qvec[0], qvec[1], qvec[2]);
					
					theta = theta + delta;
				}
				glEnd();
			}
		}//#IF(mo2->numOfRings==0..)
		else if (i%( 5-mo2->numOfRings) == 0 || (i==0 || i==mo2->numPoints-1)) {

			glBegin( GL_LINE_STRIP );
			while( theta <=4.0*M_PI+delta ) {

				//compute q(theta, vhat)
				q->r = cos( theta/2.0 );
				q->i = tangent[0]*sin( theta/2.0 );
				q->j = tangent[1]*sin( theta/2.0 );
				q->k = tangent[2]*sin( theta/2.0 );
				//printf("[t=%f] norm(q) = %f\n", theta, qNorm(q) );
				
				quatQuatProduct( q, b, f );
				//f->r = q->r*b->r - q->i*b->i - q->j*b->j - q->k*b->k;
				//f->i = q->i*b->r + q->r*b->i + q->j*b->k - q->k*b->j;
				//f->j = q->j*b->r + q->r*b->j + q->k*b->i - q->i*b->k;
				//f->k = q->k*b->r + q->r*b->k + q->i*b->j - q->j*b->i;

				//printf("[t=%f] norm(F) = %f\n", theta, qNorm(f) );

				getQuatComp( mo2->qwhichQuatComponent, f, qvec );
				
				glVertex3f(qvec[0], qvec[1], qvec[2]);
				
				theta = theta + delta;
			}
			glEnd();
		}
		glPopAttrib();
	}//# FOR(i..)
	glPopMatrix();
}

void TEST ( void ) 
{
#ifndef TESTING
#define TESTING
#endif
	double		m[16];
	quaternion	*q, *p, *r;					// quaternion
	double a = M_PI/4.0;
	double s = sin(a);
	double c = cos(a);

	//init quaternions
	p =	(quaternion*) my_malloc(sizeof(quaternion));
	q =	(quaternion*) my_malloc(sizeof(quaternion));
	r =	(quaternion*) my_malloc(sizeof(quaternion));

	printf(">>> TEST CASES\n\n");

	//TESTING quatQuatProd;
	p->r = 1.0; p->i = p->j = p->k = 0.0;

	printf("IDENTITY Quaternion: \n");
	printf("I = %f, %f, %f, %f\n",p->r, p->i, p->j, p->k );
	printf("testing... quatToRotationMatrix( I ) = \n");
	quatToRotationMatrix( p, m );
	printf("\n");

	printf("testing... ExtractQuaternionFromMat( m ) = \n");
	m[0] = 1; m[4] = 0;	m[8] = 0; m[12] = 0;
	m[1] = 0; m[5] = 1; m[9] = 0; m[13] = 0;
	m[2] = 0; m[6] = 0; m[10]= 1; m[14] = 0;
	m[3] = 0; m[7] = 0; m[11]= 0; m[15] = 1;
	ExtractQuaternionFromMat( m, q );
	printf("[I] q= %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	printf("\n");

	printf("testing... quatQuatProduct( I*i ) = i:\n");
	p->r = 1.0; p->i = p->j = p->k = 0.0;
	q->i = 1.0; q->r = q->j = q->k = 0.0;
	printf("I = %f, %f, %f, %f\n",p->r, p->i, p->j, p->k );
	printf("i = %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	quatQuatProduct( p, q, r );
	printf(" I*i = %f, %f, %f, %f\n",r->r, r->i, r->j, r->k );
	printf("\n");

	printf("testing... quatQuatProduct( i*j ) = k:\n");
	p->i = 1.0; p->r = p->j = p->k = 0.0;
	q->j = 1.0; q->r = q->i = q->k = 0.0;
	printf("i = %f, %f, %f, %f\n",p->r, p->i, p->j, p->k );
	printf("j = %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	quatQuatProduct( p, q, r );
	printf("i*j = k = %f, %f, %f, %f\n",r->r, r->i, r->j, r->k );
	printf("\n");

	printf("Obtaining back rotation matrix for k:\n");
	quatToRotationMatrix( r, m );
	printf("\n");

	printf("testing... ExtractQuaternionFromMat( k ) = \n");
	m[0] =-1; m[4] = 0;	m[8] = 0; m[12] = 0;
	m[1] = 0; m[5] =-1; m[9] = 0; m[13] = 0;
	m[2] = 0; m[6] = 0; m[10]= 1; m[14] = 0;
	m[3] = 0; m[7] = 0; m[11]= 0; m[15] = 1;
	ExtractQuaternionFromMat( m, q );
	printf("    k= %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	printf("\n");

	printf("Changing order for mult: j*i\n");
	p->i = 1.0; p->r = p->j = p->k = 0.0;
	q->j = 1.0; q->r = q->i = q->k = 0.0;
	printf("i = %f, %f, %f, %f\n",p->r, p->i, p->j, p->k );
	printf("j = %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	quatQuatProduct( q, p, r );
	printf(" j*i = %f, %f, %f, %f\n",r->r, r->i, r->j, r->k );
	printf("\n");

	printf("Obtaining back rotation matrix for -k:\n");
	quatToRotationMatrix( r, m );
	printf("\n");

	printf("testing... ExtractQuaternionFromMat( -k ) = \n");
	m[0] =-1; m[4] = 0;	m[8] = 0; m[12] = 0;
	m[1] = 0; m[5] =-1; m[9] = 0; m[13] = 0;
	m[2] = 0; m[6] = 0; m[10]= 1; m[14] = 0;
	m[3] = 0; m[7] = 0; m[11]= 0; m[15] = 1;
	ExtractQuaternionFromMat( m, q );
	printf("    k= %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	printf("\n");

	printf("Obtaining back rotation matrix for -I:\n");
	p->r = -1.0; p->i = p->j = p->k = 0.0;
	quatToRotationMatrix( p, m );
	printf("\n");

	a = M_PI/4.0;
	s = sin(a);
	c = cos(a);
	printf("testing... Rotation by 45-deg along 0,0,1 = \n");
	m[0] = c; m[4] =-s;	m[8] = 0; m[12] = 0;
	m[1] = s; m[5] = c; m[9] = 0; m[13] = 0;
	m[2] = 0; m[6] = 0; m[10]= 1; m[14] = 0;
	m[3] = 0; m[7] = 0; m[11]= 0; m[15] = 1;
	ExtractQuaternionFromMat( m, q );
	printf("   q= %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	printf("\n");

	a = M_PI/2.0;
	s = sin(a);
	c = cos(a);
	printf("testing... Rotation by 90-deg along 0,0,1 = \n");
	m[0] = c; m[4] =-s;	m[8] = 0; m[12] = 0;
	m[1] = s; m[5] = c; m[9] = 0; m[13] = 0;
	m[2] = 0; m[6] = 0; m[10]= 1; m[14] = 0;
	m[3] = 0; m[7] = 0; m[11]= 0; m[15] = 1;
	ExtractQuaternionFromMat( m, q );
	printf("   q= %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	printf("\n");

	a = M_PI;
	s = sin(a);
	c = cos(a);
	printf("testing... Rotation by 180-deg along 0,0,1 = \n");
	m[0] = c; m[4] =-s;	m[8] = 0; m[12] = 0;
	m[1] = s; m[5] = c; m[9] = 0; m[13] = 0;
	m[2] = 0; m[6] = 0; m[10]= 1; m[14] = 0;
	m[3] = 0; m[7] = 0; m[11]= 0; m[15] = 1;
	ExtractQuaternionFromMat( m, q );
	printf("   q= %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	printf("\n");

	a = (M_PI/180.0)*33.0;
	s = sin(a);
	c = cos(a);
	printf("testing... Rotation by 33-deg along 0,0,1 = \n");
	m[0] = c; m[4] =-s;	m[8] = 0; m[12] = 0;
	m[1] = s; m[5] = c; m[9] = 0; m[13] = 0;
	m[2] = 0; m[6] = 0; m[10]= 1; m[14] = 0;
	m[3] = 0; m[7] = 0; m[11]= 0; m[15] = 1;
	ExtractQuaternionFromMat( m, q );
	printf("   q= %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	printf("manual calc of q: = q(cos(theta/2.0), vhat*sin(theta/2.0))\n");
	q->r = cos(a/2.0);
	q->i = q->j = 0.0;
	q->k = 1.0*sin(a/2.0);
	printf("   q= %f, %f, %f, %f\n",q->r, q->i, q->j, q->k );
	printf("\n");
#undef TESTING

}